Package: command
Type: Package
Title: Process Command Line Arguments
Version: 0.2.0
Authors@R: c(
    person(given = "John",
           family = "Bryant",
	   email = "john@bayesiandemography.com",
	   role = c("aut", "cre")),
    person("Bayesian Demography Limited",
            role = "cph"))
Description: Process command line arguments, allowing scripts to
    behave like functions, with well-defined inputs and outputs.
    Helps make data analysis workflows more modular,
    and therefore more transparent, flexible, and reliable.
License: MIT + file LICENSE
Encoding: UTF-8
Depends: R (>= 3.5.0)
Imports: cli, methods, tools
Suggests: covr, dplyr, ggplot2, knitr, littler, quarto, readr,
        rmarkdown, testthat (>= 3.0.0), tidyr, withr
Config/testthat/edition: 3
URL: https://bayesiandemography.github.io/command/,
        https://github.com/bayesiandemography/command
Config/Needs/website: quarto, rmarkdown, fs
BugReports: https://github.com/bayesiandemography/command/issues
Config/roxygen2/version: 8.0.0
NeedsCompilation: no
Packaged: 2026-07-23 01:03:29 UTC; johnbryant
Author: John Bryant [aut, cre],
  Bayesian Demography Limited [cph]
Maintainer: John Bryant <john@bayesiandemography.com>
Repository: CRAN
Date/Publication: 2026-07-23 02:40:02 UTC
Built: R 4.6.1; ; 2026-07-23 02:44:10 UTC; unix

<!-- README.md is generated from README.Rmd. Please edit that file -->

<a href="https://github.com/bayesiandemography/command">
<img src="man/figures/sticker.png"
       style="float:right; height:138px;" /> </a>

# command

<!-- badges: start -->

[![Lifecycle:
experimental](https://img.shields.io/badge/lifecycle-experimental-orange.svg)](https://lifecycle.r-lib.org/articles/stages.html#experimental)
[![R-CMD-check](https://github.com/bayesiandemography/command/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/bayesiandemography/command/actions/workflows/R-CMD-check.yaml)
[![Codecov test
coverage](https://codecov.io/gh/bayesiandemography/command/branch/main/graph/badge.svg)](https://app.codecov.io/gh/bayesiandemography/command?branch=main)
[![CRAN
status](https://www.r-pkg.org/badges/version/command)](https://CRAN.R-project.org/package=command)
<!-- badges: end -->

Process command line arguments as part of data analysis workflow.

The main function is
[cmd_assign()](https://bayesiandemography.github.io/command/reference/cmd_assign.html).

For an overview of the package, see [Quick
Start](https://bayesiandemography.github.io/command/articles/a1_quickstart.html).

For ideas on building safe, modular workflows, see [Modular Workflows
for Data
Analysis](https://bayesiandemography.github.io/command/articles/a4_workflow.html).

## Installation

``` r
install.packages("command")
```

## Example

``` r
cmd_assign(.data = "data/raw_data.csv",
           date_start = "2025-01-01",
           trim_outliers = TRUE,
           .out = "out/cleaned_data.rds")
```

suppressPackageStartupMessages({
  library(dplyr)
  library(tidyr)
  library(command)
})

cmd_assign(.cleaned_data = "out/cleaned_data.rds",
           .model_m = "out/model_m.rds",
           .model_mm = "out/model_mm.rds",
           .out = "out/vals_fitted.rds")

cleaned_data <- readRDS(.cleaned_data)
model_m <- readRDS(.model_m)
model_mm <- readRDS(.model_mm)

vals_fitted <- cleaned_data |>
  mutate(m = fitted(model_m),
         mm = fitted(model_mm)) |>
  pivot_longer(c(m, mm),
               names_to = "variant",
               values_to = "fitted")
           
saveRDS(vals_fitted, file = .out)

## Specify packages, inputs, and outputs ------------------

suppressPackageStartupMessages({
  library(dplyr)
  library(ggplot2)
  library(command)
})

cmd_assign(.airmiles = "data/airmiles.csv",
           n_knot = 10,
           .out = "fig_smoothed.png")


## Read in data -------------------------------------------

airmiles <- read.csv(.airmiles)


## Analyse ------------------------------------------------

smoothed <- airmiles |>
  mutate(smoothed = fitted(smooth.spline(x = passengers,
                                         nknots = n_knot)))

p <- ggplot(smoothed, aes(x = year)) +
  geom_line(aes(y = smoothed)) +
  geom_point(aes(y = passengers)) +
  ggtitle(paste("Smoothed using", n_knot, "knots"))


## Save results -------------------------------------------

png(file = .out, width = 200, height = 200)
plot(p)
dev.off()

suppressPackageStartupMessages({
  library(dplyr)
  library(tidyr)
  library(command)
})

cmd_assign(.cleaned_data = "out/cleaned_data.rds",
           .model = "out/model.rds",
           .out = "out/vals_fitted.rds")

cleaned_data <- readRDS(.cleaned_data)
model <- readRDS(.model)

vals_fitted <- cleaned_data |>
  mutate(fitted = fitted(model))
           
saveRDS(vals_fitted, file = .out)

suppressPackageStartupMessages({
  library(ggplot2)
  library(command)
})

cmd_assign(.vals_fitted = "out/vals_fitted.rds",
           .out = "out/fig_fitted.png")

vals_fitted <- readRDS(.vals_fitted)

p <- ggplot(vals_fitted, aes(x = agriculture)) +
  geom_point(aes(y = fertility)) +
  geom_line(aes(y = fitted))
               
png(file = .out,
    width = 400,
    height = 300)
plot(p)
dev.off()

suppressPackageStartupMessages({
  library(MASS)
  library(command)
})

cmd_assign(.cleaned_data = "out/cleaned_data.rds",
           rlm_method = "M",
           .out = "out/model.rds")

cleaned_data <- readRDS(.cleaned_data)

model <- rlm(fertility ~ agriculture, 
             data = cleaned_data,
             method = rlm_method)

saveRDS(model, file = .out)

suppressPackageStartupMessages({
  library(MASS)
  library(command)
})

cmd_assign(.cleaned_data = "out/cleaned_data.rds",
           method = "M",
           .out = "out/model.rds")

cleaned_data <- readRDS(.cleaned_data)

model <- rlm(fertility ~ agriculture, 
             data = cleaned_data,
             method = "M")

saveRDS(model, file = .out)

## HAS_TESTS
#' Check Values Passed at Command Line
#'
#' Check that any named argument passed
#' at command line are also found in 'dots',
#' and that the number of arguments passed
#' at the command line matches the number
#' present in 'dots'.
#'
#' @param args_cmd A list, possibly with names.
#' @param args_dots A named list.
#' 
#' @return TRUE, invisibly.
#'
#' @noRd
check_args_cmd <- function(args_cmd, args_dots) {
  nms_cmd <- names(args_cmd)
  nms_dots <- names(args_dots)
  nms_cmd_nzchar <- nms_cmd[nzchar(nms_cmd)]
  ## any named arguments used in the command line
  ## should be present in dots
  for (nm in nms_cmd) {
    if (nzchar(nm) && !(nm %in% nms_dots)) {
      cli::cli_abort(c("Problem with argument {.arg {nm}}.",
                       i = paste("Named argument {.arg {nm}} passed at command line",
                                 "but not specified with {.fun cmd_assign}."),
                       i = "Argument{?s} specified with {.fun cmd_assign}: {.arg {nms_dots}}."))
    }
  }
  ## number of arguments passed at command line should
  ## match number of arguments specified in dots
  n_cmd <- length(args_cmd)
  n_dots <- length(args_dots)
  if (n_cmd != n_dots) {
    n_cmd_nzchar <- length(nms_cmd_nzchar)
    n_cmd_zchar <- n_cmd - n_cmd_nzchar
    msg <- c(paste("Mismatch between arguments passed at command line",
                   "and arguments specified with {.fun cmd_assign}."),
             i = paste("{.val {n_cmd_nzchar}} named argument{?s} and",
                       "{.val {n_cmd_zchar}} unnamed argument{?s}",
                       "passed at command line."),
             i = "{.val {n_dots}} argument{?s} specified with {.fun cmd_assign}.")
    if (n_cmd_nzchar > 0L)
      msg <- c(msg,
               i = "Named argument{?s} passed at command line: {.arg {nms_cmd_nzchar}}.")
    msg <- c(msg,
             i = "Argument{?s} specified with {.fun cmd_assign}: {.arg {nms_dots}}.")
    cli::cli_abort(msg)
  }
  ## no problems found
  invisible(TRUE)
}


## HAS_TESTS
#' Check Arguments Supplied to 'cmd_assign'
#' Through the Dots
#'
#' Check that names and values supplied
#' to [cmd_assign()] via the dots
#' argument are valid.
#'
#' Valid classes: character, integer, numeric, logical,
#'                Date, POSIXct, POSIXlt
#'
#' @param args_dots Dots argument from
#' [cmd_assign()].
#'
#' @return TRUE, invisibly
#'
#' @noRd
check_args_dots <- function(args_dots) {
  n <- length(args_dots)
  nms <- names(args_dots)
  check_names_args(nms)
  is_character <- vapply(args_dots, is.character, NA, USE.NAMES = FALSE)
  is_integer <- vapply(args_dots, is.integer, NA, USE.NAMES = FALSE)
  is_numeric <- vapply(args_dots, is.numeric, NA, USE.NAMES = FALSE)
  is_logical <- vapply(args_dots, is.logical, NA, USE.NAMES = FALSE)
  is.Date <- function(x) methods::is(x, "Date")
  is.POSIXct <- function(x) methods::is(x, "POSIXct")
  is.POSIXlt <- function(x) methods::is(x, "POSIXlt")
  is_Date <- vapply(args_dots, is.Date, NA, USE.NAMES = FALSE)
  is_POSIXct <- vapply(args_dots, is.POSIXct, NA, USE.NAMES = FALSE)
  is_POSIXlt <- vapply(args_dots, is.POSIXlt, NA, USE.NAMES = FALSE)
  is_null <- vapply(args_dots, is.null, NA, USE.NAMES = FALSE)
  is_valid <- (is_character | is_logical | is_numeric | is_logical
    | is_Date | is_POSIXct | is_POSIXlt | is_null)
  i_invalid <- match(FALSE, is_valid, nomatch = 0L)
  if (i_invalid > 0L) {
    nm_invalid <- nms[[i_invalid]]
    val_invalid <- args_dots[[i_invalid]]
    cls_invalid <- class(val_invalid)
    valid_classes <- c("character", "integer", "numeric", "logical",
                       "Date", "POSIXct", "POSIXlt", "NULL")
    cli::cli_abort(c("Can't process argument {.arg {nm_invalid}} in call to {.fun cmd_assign}.",
                     i = "{.arg {nm_invalid}} has class {.val {cls_invalid}}.",
                     i = paste("{.fun cmd_assign} can only process arguments with classes",
                               "{.val {valid_classes}}.")))
  }
  lengths <- lengths(args_dots)
  is_valid_length <- ifelse(is_null, lengths == 0L, lengths == 1L)
  i_invalid_length <- match(FALSE, is_valid_length, nomatch = 0L)
  if (i_invalid_length > 0L) {
    nm_invalid_length <- nms[[i_invalid_length]]
    invalid_length <- lengths[[i_invalid_length]]
    cli::cli_abort(paste("Argument {.arg {nm_invalid_length}} in call to {.fun cmd_assign}",
                         "has length {.val {invalid_length}}."))
  }
  invisible(TRUE)
}


## HAS_TESTS
#' Check Name used for Makefile or Shell Script
#'
#' @param name String, valid as filename
#'
#' @returns TRUE, invisibly
#'
#' @noRd
check_dir <- function(dir, nm) {
  if (!identical(length(dir), 1L))
    cli::cli_abort("{.arg {nm}} does not have length 1.")
  if (!dir.exists(dir))
    cli::cli_abort(c("Problem with {.arg {nm}}.",
                     i = "Directory {.file {dir}} does exist."))
  invisible(TRUE)
}


## HAS_TESTS
#' Check File Exists, with Helpful Error Messages
#'
#' Check that file exists, with path starting at 'dir'.
#' Give helpful messages, since relative vs absolute
#' paths etc are potentially confusing.
#'
#' @param File Path from Makefile or shell script
#' to file with R code
#' @param dir Directory where Makefile or shell script exists
#' (typically the project directory)
#' @param nm_dir_arg Name of argument used
#' for directory. "dir_make" or "dir_shell"
#' @param has_dir_arg Whether the user supplied
#' an explicit argument for the Makefile or shell script
#' directory. (If not, default to current working directory.)
#'
#' @returns TRUE, invisibly
#'
#' @noRd
check_path_file_valid <- function(path_file, dir, nm_dir_arg, has_dir_arg) {
  if (is_absolute_path(path_file))
    cli::cli_abort(c("{.arg path_file} is an absolute path.",
                     i = "{.arg path_file}: {.path {path_file}}.",
                     i = "{.arg path_file} must be a relative path."))
  path_file_comb <- path_join(dir, path_file)
  if (!file.exists(path_file_comb)) {
    msg1 <- "Can't find R script."
    if (has_dir_arg)
      msg2 <- paste("Path to R script constructed from",
                    "{.arg path_file} and {.arg {nm_dir_arg}}.")
    else
      msg2 <- paste("No value for {.arg {nm_dir_arg}} supplied, so path to",
                    "R script assumed to start from current working directory.")
    msg3 <- "Path: {.path {path_file_comb}}"
    msg <- c(msg1, i = msg2, i = msg3)
    cli::cli_abort(msg)
  }
  invisible(TRUE)
}  


## HAS_TESTS
#' Check Directory Specified by 'path_files' and 'dir' Exists,
#' with Helpful Error Messages
#'
#' Check that directory implied by 'dir' and
#' 'path_files' exists.
#' Give helpful messages, since relative vs absolute
#' paths etc are potentially confusing.
#'
#' @param path_files Path from Makefile or shell script
#' to directory with files with R code
#' @param dir Directory where Makefile or shell script exists
#' (typically the project directory)
#' @param nm_dirt_arg Name of argument used
#' for directory ("dir_make" or "dir_shell")
#' @param has_dir_arg Whether the user supplied
#' an explicit argument for the Makefile or shell script
#' directory. (If not, default to current working directory.)
#'
#' @returns TRUE, invisibly
#'
#' @noRd
check_path_files_valid <- function(path_files, dir, nm_dir_arg, has_dir_arg) {
  if (is_absolute_path(path_files))
    cli::cli_abort(c("{.arg path_files} is an absolute path.",
                     i = "{.arg path_files}: {.path {path_files}}.",
                     i = "{.arg path_files} must be a relative path."))
  path_files_comb <- path_join(dir, path_files)
  if (!dir.exists(path_files_comb)) {
    msg1 <- "Can't find directory containing R scripts."
    if (has_dir_arg)
      msg2 <- paste("Path to directory constructed from",
                    "{.arg path_files} and {.arg {nm_dir_arg}}.")
    else
      msg2 <- paste("No value for {.arg {nm_dir_arg}} supplied, so path to",
                    "{.arg path_files} directory assumed to start",
                    "from current working directory.")
    msg3 <- "Path: {.path {path_files_comb}}"
    msg <- c(msg1, i = msg2, i = msg3)
    cli::cli_abort(msg)
  }
  invisible(TRUE)
}



## HAS_TESTS
#' Check a Logical Flag
#'
#' @param x TRUE or FALSE
#' @param nm Name for 'x' to use in error messages.
#'
#' @returns TRUE, invisibly
#' 
#' @noRd
check_flag <- function(x, nm) {
  if (!identical(length(x), 1L))
    cli::cli_abort(c("{.arg {nm}} does not have length 1",
                     i = "{.arg {nm}} has length {length(x)}."))
  if (!is.logical(x))
    cli::cli_abort(c("{.arg {nm}} does not have class {.cls logical}.",
                     i = "{.arg {nm}} has class {.cls {class(x)}}"))
  if (is.na(x))
    cli::cli_abort("{.arg {nm}} is {.val {NA}}")
  invisible(TRUE)
}


## HAS_TESTS
#' Check that a File Contains R Code
#'
#' @param file Path to R code file
#'
#' @returns TRUE, invisibly
#'
#' @noRd
check_is_r_code <- function(file) {
  R <- "R"
  r <- "r"
  if (!file.exists(file))
    cli::cli_abort("File {.file {file}} does not exist.")
  ext <- tools::file_ext(file)
  if (!ext %in% c(R, r))
    cli::cli_alert_warning("File {.file {file}} does not have extension {.val {R}} or {.val {r}}.")
  value <- tryCatch(parse(file = file),
                    error = function(e) e)
  if (inherits(value, "error"))
    cli::cli_abort(c("Can't parse file {.file {file}}.",
                     i = value$message))
  invisible(TRUE)
}
  

## HAS_TESTS
#' Check that Argument Names are Valid
#'
#' Check that names are not NULL, NA, blank,
#' or duplicated. Also check that they are
#' valid names for R objects
#'
#' @param nms A character vector
#'
#' @returns TRUE, invisibly
#'
#' @noRd
check_names_args <- function(nms) {
  if (is.null(nms))
    cli::cli_abort("Arguments do not have names.")
  if (anyNA(nms))
    cli::cli_abort(c("Argument names include {.val {NA}}.",
                     i = "Argument names: {.val {nms}}."))
  if (!all(nzchar(nms)))
    cli::cli_abort(c("Argument name with length 0.",
                     i = "Argument names: {.val {nms}}."))
  i_dup <- match(TRUE, duplicated(nms), nomatch = 0L)
  if (i_dup > 0L)
    cli::cli_abort(c("More than one argument named {.val {nms[[i_dup]]}}.",
                     i = "Argument names: {.val {nms}}."))
  is_valid <- vapply(nms, is_varname_valid, TRUE)
  i_invalid <- match(FALSE, is_valid, nomatch = 0L)
  if (i_invalid > 0L)
    cli::cli_abort(c("Argument name not a valid name for an R object.",
                     i = "Invalid name: {.val {nms[[i_invalid]]}}.",
                     i = "Argument names: {.val {nms}}."))
  invisible(TRUE)
}


## HAS_TESTS
#' Check Whether a String Could be a Valid Filename
#'
#' @param x String
#' @param nm Name of string to be used
#' in error messages.
#'
#' @returns TRUE, invisibly
#'
#' @noRd
check_valid_filename <- function(x, nm) {
  if (!is.character(x))
    cli::cli_abort("{.arg {nm}} is not a character string.")
  if (length(x) != 1L)
    cli::cli_abort("{.arg {nm}} does not have length 1.")
  if (!nzchar(x))
    cli::cli_abort("{.arg {nm}} is blank.")
  if (grepl("[/\\:*?\"<>|]", x))
    cli::cli_abort("{.arg {nm}} contains invalid character.")
  invisible(TRUE)
}

## 'check_args_cmd' ----------------------------------------------------------

test_that("'check_args_cmd' returns TRUE when 'args_cmd' valid", {
  args_cmd <- list("file1", "file2", n_iter = 3)
  args_dots  <- list(f1 = "f1", f2 = "f2", n_iter = 2)
  expect_true(check_args_cmd(args_cmd = args_cmd,
                             args_dots = args_dots))
  expect_true(check_args_cmd(args_cmd = args_cmd,
                             args_dots = rev(args_dots)))
})

test_that("'check_args_cmd' returns TRUE when 'args_cmd' empty", {
  args_cmd <- list()
  args_dots  <- list()
  expect_true(check_args_cmd(args_cmd = args_cmd,
                             args_dots = args_dots))
})

test_that("'check_args_cmd' throws expected error when named passed at command line not found in dots", {
  ## two dots arg
  args_cmd <- list("file1", wrong = 3)
  args_dots  <- list(f1 = "f1", n_iter = 10)
  expect_error(check_args_cmd(args_cmd = args_cmd,
                              args_dots = args_dots),
               "Problem with argument `wrong`.")
  ## one dots arg
  args_cmd <- list("file1", wrong = 3)
  args_dots  <- list(f1 = "f1")
  expect_error(check_args_cmd(args_cmd = args_cmd,
                              args_dots = args_dots),
               "Problem with argument `wrong`.")
})

test_that("'check_args_cmd' throws expected error lengths of 'args_cmd' 'args_dots' differ", {
  args_cmd <- list("file1", "file2", n_iter = 3)
  args_dots  <- list(f1 = "f1", n_iter = 10)
  expect_error(check_args_cmd(args_cmd = args_cmd,
                              args_dots = args_dots),
               paste("Mismatch between arguments passed at command line and arguments",
                     "specified with `cmd_assign\\(\\)`."))
})

test_that("'check_args_cmd' throws expected error lengths of 'args_cmd' 'args_dots' differ - no named args", {
  args_cmd <- list("file1", "file2")
  args_dots  <- list(f1 = "f1")
  expect_error(check_args_cmd(args_cmd = args_cmd,
                              args_dots = args_dots),
               paste("Mismatch between arguments passed at command line and arguments",
                     "specified with `cmd_assign\\(\\)`."))
})


## 'check_args_dots' ----------------------------------------------------------

test_that("'check_args_dots' returns TRUE when 'args_dots' valid", {
  expect_true(check_args_dots(args_dots = list(a = "1",
                                               b = 2L,
                                               c = 3.0,
                                               d = as.Date("2001-01-01"),
                                               e = as.POSIXct("2001-01-01 11:11:11"),
                                               f = as.POSIXlt("2001-01-01 11:11:11"),
                                               g = NULL)))
})

test_that("'check_args_dots' throws error when values are invalid", {
    expect_error(check_args_dots(args_dots = list(a = raw(), b = 2)),
                 "Can't process argument `a` in call to `cmd_assign\\(\\)`.")
})

test_that("'check_args_dots' throws error when values have wrong length", {
    expect_error(check_args_dots(args_dots = list(a = "x", b = 2:1)),
                 "Argument `b` in call to `cmd_assign\\(\\)` has length 2.")
    expect_error(check_args_dots(args_dots = list(a = "x", b = integer())),
                 "Argument `b` in call to `cmd_assign\\(\\)` has length 0.")
})


## 'check_dir' ----------------------------------------------------------------

test_that("'check_dir' works with valid inputs", {
  dir_tmp <- tempfile(tmpdir = getwd())
  if (!file.exists(dir_tmp))
    dir.create(dir_tmp)
  expect_true(check_dir(dir_tmp, nm = "x"))
})

test_that("'check_dir' throws error when dir length != 1", {
  expect_error(check_dir(c("a", "b"), nm = "x"),
               "`x` does not have length 1.")
  expect_error(check_dir(character(), nm = "x"),
               "`x` does not have length 1.")
})

test_that("'check_dir' throws error when dir does not exist", {
  if (!file.exists("wrong/wrong_again")) {
    expect_error(check_dir("wrong/wrong_again", nm = "x"),
                 "Problem with `x`.")
  }
})


## 'check_path_file_valid' ----------------------------------------------------

test_that("'check_path_file_valid' returns true with valid inputs, with dir specified", {
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  writeLines("x <- 1",
             con = path_join(dir_tmp, "script.R"))
  expect_true(check_path_file_valid(path_file = "script.R",
                                    dir = dir_tmp,
                                    nm_dir_arg = "d",
                                    has_dir_arg = TRUE))
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'check_path_file_valid' returns true with valid inputs, with dir not specified", {
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  writeLines("x <- 1",
             con = path_join(dir_tmp, "script.R"))
  expect_true(check_path_file_valid(path_file = path_join(path_rel(dir_tmp, getwd()), "script.R"),
                                    dir = getwd(),
                                    nm_dir_arg = "d",
                                    has_dir_arg = FALSE))
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'check_path_files_valid' throws correct error, with absolute path", {
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  expect_error(check_path_file_valid(path_file = "C:/",
                                     dir = dir_tmp,
                                     nm_dir_arg = "dir_make",
                                     has_dir_arg = TRUE),
               "`path_file` is an absolute path.")
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'check_path_file_valid' throws correct error, with dir specified", {
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  expect_error(check_path_file_valid(path_file = "wrong",
                                     dir = dir_tmp,
                                     nm_dir = "d",
                                     has_dir_arg = TRUE),
               "Can't find R script.")
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'check_path_file_valid' throws correct error, with dir not specified", {
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  expect_error(check_path_file_valid(path_file = "wrong",
                                     dir = getwd(),
                                     nm_dir = "d",
                                     has_dir_arg = FALSE),
               "Can't find R script.")
  unlink(dir_tmp, recursive = TRUE)
})


## 'check_path_files_valid' ---------------------------------------------------

test_that("'check_path_files_valid' returns true with valid inputs, with dir specified", {
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  dir.create(path_join(dir_tmp, "src"))
  expect_true(check_path_files_valid(path_files = "src",
                                 dir = dir_tmp,
                                 nm_dir_arg = "dir_make",
                                 has_dir_arg = TRUE))
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'check_path_files_valid' returns true with valid inputs, with dir not specified", {
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  dir.create(path_join(dir_tmp, "src"))
  expect_true(check_path_files_valid(path_files = path_join(path_rel(dir_tmp, getwd()), "src"),
                                 dir = getwd(),
                                 nm_dir_arg = "dir_make",
                                 has_dir_arg = FALSE))
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'check_path_files_valid' throws correct error, with absolute path", {
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  expect_error(check_path_files_valid(path_files = "C:/",
                                      dir = dir_tmp,
                                      nm_dir_arg = "dir_make",
                                      has_dir_arg = TRUE),
               "`path_files` is an absolute path.")
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'check_path_files_valid' throws correct error, with dir specified", {
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  expect_error(check_path_files_valid(path_files = "wrong",
                                  dir = dir_tmp,
                                  nm_dir_arg = "dir_make",
                                  has_dir_arg = TRUE),
               "Can't find directory containing R scripts.")
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'check_path_files_valid' throws correct error, with dir not specified", {
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  expect_error(check_path_files_valid(path_files = "wrong",
                                 dir = getwd(),
                                 nm_dir_arg = "dir_make",
                                 has_dir_arg = FALSE),
               "Can't find directory.")
  unlink(dir_tmp, recursive = TRUE)
})


## 'check_flag' ---------------------------------------------------------------

test_that("'check_flag' returns TRUE with valid inputs", {
  x <- TRUE
  expect_true(check_flag(x, nm = "x"))
  x <- FALSE
  expect_true(check_flag(x))
})

test_that("'check_flag' throws expected error non-length-1", {
  y <- logical()
  expect_error(check_flag(y, nm = "z"),
               "`z` does not have length 1")
  z <- c(TRUE, TRUE)
  expect_error(check_flag(z, nm = "z"),
               "`z` does not have length 1")
})

test_that("'check_flag' throws expected error non-logical", {
  x <- "hello"
  expect_error(check_flag(x, nm = "x"),
               "`x` does not have class <logical>")
})

test_that("'check_flag' throws expected error NA", {
  x <- NA
  expect_error(check_flag(x, nm = "xx"),
               "`xx` is NA")
})


## 'check_is_r_code' -------------------------------------------------------------

test_that("'check_is_r_code' works with valid inputs", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  setwd(dir_tmp)
  writeLines("x <- 1",
             con = "script.R")
  ans <- check_is_r_code("script.R")
  expect_true(ans)
  setwd(dir_curr)
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'check_is_r_code' throws error when file does not exist", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  setwd(dir_tmp)
  expect_error(check_is_r_code("wrong.R"),
                 "File 'wrong\\.R' does not exist.")
  setwd(dir_curr)
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'check_is_r_code' gives warning with no R extension", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  setwd(dir_tmp)
  writeLines("x <- 1",
             con = "script.c")
  expect_message(check_is_r_code("script.c"),
                 "File 'script\\.c' does not have extension \"R\" or \"r\"\\.")
  setwd(dir_curr)
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'check_is_r_code' gives error when file invalid", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  setwd(dir_tmp)
  dir.create("dd")
  writeLines("wrong wrong wrong",
             con = "dd/script.R")
  expect_error(check_is_r_code("dd/script.R"),
               "Can't parse file 'dd/script\\.R'.")
  setwd(dir_curr)
  unlink(dir_tmp, recursive = TRUE)
})


## 'check_names_args' ---------------------------------------------------------

test_that("'check_names_args' returns TRUE when 'nms' valid", {
    expect_true(check_names_args(nms = c("a", "b")))
})

test_that("'check_names_args' throws error when nms NULL", {
  expect_error(check_names_args(nms = NULL),
               "Arguments do not have names.")
})

test_that("'check_names_args' throws error when nms has NA", {
  expect_error(check_names_args(nms = c("a", NA, "b", NA)),
               "Argument names include NA.")
})

test_that("'check_names_args' throws error when nms has blank", {
  expect_error(check_names_args(nms = c("a", "", "b", "bb")),
               "Argument name with length 0.")
})

test_that("'check_names_args' throws error when nms has duplicate", {
  expect_error(check_names_args(nms = c("a", "bb", "b", "bb")),
               "More than one argument named \"bb\".")
})

test_that("'check_names_args' throws error when nms has invalid name", {
  expect_error(check_names_args(nms = c("a", "1", "b", "bb")),
               "Argument name not a valid name for an R object.")
})


## 'check_valid_filename' -----------------------------------------------------

test_that("check_valid_filename works with valid inputs", {
  expect_invisible(result <- check_valid_filename("file.csv", nm = "x"))
  expect_true(result)
  expect_invisible(result <- check_valid_filename("valid_file-name.txt", nm = "x"))
  expect_true(result)
})

test_that("check_valid_filename fails with non-character input", {
  expect_error(check_valid_filename(42, nm = "x"), "`x` is not a character string")
  expect_error(check_valid_filename(TRUE, nm = "x"), "`x` is not a character string")
})

test_that("check_valid_filename failes with length != 1", {
  expect_error(check_valid_filename(character(0), nm = "x"), "`x` does not have length 1")
  expect_error(check_valid_filename(c("file1", "file2"), nm = "x"), "`x` does not have length 1")
})

test_that("check_valid_filename fails with blank", {
  expect_error(check_valid_filename("", nm = "x"), "`x` is blank")
})

test_that("check_valid_filename fails with invalid character", {
  expect_error(check_valid_filename("bad/name.txt", nm = "x"),
               "`x` contains invalid character.")
  expect_error(check_valid_filename("bad\\name.txt", nm = "x"),
               "`x` contains invalid character.")
  expect_error(check_valid_filename("bad:name.txt", nm = "x"),
               "`x` contains invalid character.")
  expect_error(check_valid_filename("bad*name.txt", nm = "x"),
               "`x` contains invalid character.")
  expect_error(check_valid_filename("bad?name.txt", nm = "x"),
               "`x` contains invalid character.")
  expect_error(check_valid_filename("bad\"name.txt", nm = "x"),
               "`x` contains invalid character.")
  expect_error(check_valid_filename("bad<name.txt", nm = "x"),
               "`x` contains invalid character.")
  expect_error(check_valid_filename("bad>name.txt", nm = "x"),
               "`x` contains invalid character.")
  expect_error(check_valid_filename("bad|name.txt", nm = "x"),
               "`x` contains invalid character.")
})

suppressPackageStartupMessages({
  library(ggplot2)
  library(command)
})

cmd_assign(.vals_fitted = "out/vals_fitted.rds",
           .out = "out/fig_fitted.png")

vals_fitted <- readRDS(.vals_fitted)

p <- ggplot(vals_fitted, aes(x = agriculture)) +
  facet_wrap(vars(variant)) +
  geom_point(aes(y = fertility)) +
  geom_line(aes(y = fitted))
               
png(file = .out,
    width = 600,
    height = 300)
plot(p)
dev.off()

suppressPackageStartupMessages({
  library(readr)
  library(dplyr)
  library(command)
})

cmd_assign(.raw_data = "data/raw_data.csv",
           .out = "out/cleaned_data.rds")

raw_data <- read_csv(.raw_data, show_col_types = FALSE)

cleaned_data <- raw_data |>
  mutate(agriculture = scale(Agriculture),
         fertility = scale(Fertility),
         agriculture = as.numeric(agriculture),
         fertility = as.numeric(fertility)) |>
  select(province = Province, agriculture, fertility)

saveRDS(cleaned_data, file = .out)

#' Assign Values Passed at the Command Line or Interactively
#'
#' @description
#' Assign values to names in the working environment.
#' The values are typically supplied through the command line,
#' but can be supplied interactively.
#'
#' Specifying the inputs and outputs of scripts through the
#' command line can contribute to safter, more modular
#' workflows.
#'
#' `cmd_assign_quiet()` is identical to `cmd_assign()`,
#' but does not print progress messages to the console.
#'
#' @details
#' # Types of session
#'
#' `cmd_assign()` behaves differently depending
#'  on how it whether it is called
#'
#' 1. interactively, or
#' 2. inside an R script that is run from the command line.
#'
#' For instance, if the code
#'
#' `cmd_assign(use_log = TRUE)`
#'
#' is run interactively, it creates an object 
#' called `use_log` with value `TRUE`.
#'
#' But if the same code is run inside a
#' script via the command
#' 
#' `Rscript tidy_data.R --use_log=FALSE`
#' 
#' it creates an object called `use_log`
#' with value `FALSE`.
#'
#' `cmd_assign()` is typically called interactively
#' when a workflow is being developed,
#' and through the command line when the
#' workflow has matured.
#'
#' # Matching names and values
#'
#' When used in a script called from the
#' command line, `cmd_assign()`
#' first matches named command line arguments,
#' and then matches unnamed command line arguments,
#' in the order in which they are supplied.
#'
#' If, for instance, the script `person.R` contains
#' the lines
#'
#' ```
#' cmd_assign(.data = "raw_data.csv",
#'            max_age = 85,
#'            .out = "person.rds")
#' ```
#'
#' and if `person.R` is run from the command line using
#'
#' ```
#' Rscript person.R raw_data.csv person.rds --max_age=100
#' ```
#' 
#' then `cmd_assign()` first matches named
#' command line argument `--max_age=100` to `cmd_assign()
#' argument `max_age`, and then matches
#' unnamed command line arguments
#' `raw_data.csv` and `person.rds` to `cmd_assign()`
#' arugments `.data` and `.out`.
#'
#' # Coercing values passed at the command line
#' 
#' Values passed at the command line start out as
#' text strings. `cmd_assign()` coerces these text strings
#' to have the same class as the corresponding values
#' in the call to `cmd_assign()`. For instance,
#' if a script called `fit.R` contains
#' the lines
#' 
#' ```
#' cmd_assign(.data = "cleaned.rds",
#'            impute = TRUE,
#'            date = as.Date("2026-01-01"),
#'            .out = "fit.rds")
#' ```
#'
#' and if `fitted.R` is run from the command line using
#'
#' ```
#' Rscript fitted.R cleaned.rds fit.rds --impute=TRUE --date=2025-01-01
#' ```
#'
#' then `cmd_assign()` will create
#'
#' - a character vector called `.data` with value "cleaned.rds",
#' - a logical vector called `impute` with value `TRUE`,
#' - a date vector called `date` with value `"2025-01-01"`, and
#' - a character vector called `.out` with value `"fit.rds".
#'
#' @param ... Name-value pairs.
#' 
#' @returns `cmd_assign()` is called
#' for its side effect, which is to create objects
#' in the global environment. However, `cmd_assign()`
#' also invisibly returns a named list of objects.
#'
#' @seealso
#' - [extract_shell()] Turn a `cmd_assign()` call into a shell command
#' - [extract_make()] Turn a `cmd_assign()` call into a Makefile rule
#' - [shell_script()] Create a shell script
#' - [makefile()] Create a Makefile
#' - [use_renv()] Activate a renv project before loading packages
#' - [Quick Start](https://bayesiandemography.github.io/command/articles/quickstart.html)
#'   How to use `cmd_assign()`
#' - [Modular Workflows for Data Analysis](https://bayesiandemography.github.io/command/articles/workflow.html)
#'   Safe, flexible data analysis workflows.
#' - [Using command with renv](https://bayesiandemography.github.io/command/articles/a5_renv.html)
#'   Running pipeline scripts with renv
#' - Base R function [commandArgs()] uses a more general,
#'   lower-level approach to processing command line arguments.
#'   (`commandArgs()` is called internally by `cmd_assign()`.)
#' - [littler](https://CRAN.R-project.org/package=littler) Alternative to Rscript
#'
#' @references
#' - [Command-Line Programs](https://swcarpentry.github.io/r-novice-inflammation/05-cmdline.html)
#'   Introduction to Rscript
#'   
#' @examples
#' if (interactive()) {
#'   cmd_assign(.data = "mydata.csv",
#'              n_iter = 2000,
#'              .out = "results.rds")
#' }
#' @export
cmd_assign <- function(...) {
  envir <- parent.frame()
  args_dots <- list(...)
  check_args_dots(args_dots)
  if (interactive())
    args <- args_dots # nocov
  else {
    args_cmd <- get_args_cmd()
    check_args_cmd(args_cmd = args_cmd,
                   args_dots = args_dots)
    args_cmd <- align_cmd_to_dots(args_cmd = args_cmd,
                                  args_dots = args_dots)
    args_cmd <- coerce_to_dots_class(args_cmd = args_cmd,
                                     args_dots = args_dots)
    args <- args_cmd
  }
  assign_args(args = args,
              envir = envir,
              quiet = FALSE)
}

#' @export
#' @rdname cmd_assign
cmd_assign_quiet <- function(...) {
  envir <- parent.frame()
  args_dots <- list(...)
  check_args_dots(args_dots)
  if (interactive())
    args <- args_dots # nocov
  else {
    args_cmd <- get_args_cmd()
    check_args_cmd(args_cmd = args_cmd,
                   args_dots = args_dots)
    args_cmd <- align_cmd_to_dots(args_cmd = args_cmd,
                                  args_dots = args_dots)
    args_cmd <- coerce_to_dots_class(args_cmd = args_cmd,
                                     args_dots = args_dots)
    args <- args_cmd
  }
  assign_args(args = args,
              envir = envir,
              quiet = TRUE)
}

## 'makefile' -----------------------------------------------------------------

test_that("'makefile' works with has dir_make, no name_make", {
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  dir.create(path_join(dir_tmp, "src"))
  file_path <- path_join(dir_tmp, "src/script.R")
  writeLines("cmd_assign(.data = 'data/mydata.csv', use_log = FALSE, .out = 'out/cleaned.rds')",
             con = file_path)
  suppressMessages(ans_obtained <- makefile(path_files = "src", dir_make = dir_tmp))
  ans_expected <- paste0("\n",
                         ".PHONY: all\n",
                         "all:\n",
                         "\n\n",
                         "out/cleaned.rds: ", "src/script.R", " \\\n",
                         "  data/mydata.csv\n",
                         "\t", "Rscript $^ $@ --use_log=FALSE\n",
                         "\n\n",
                         ".PHONY: clean\n",
                         "clean:\n",
                         "\trm -rf out\n",
                         "\tmkdir out\n\n")
  expect_identical(ans_obtained, ans_expected)
  expect_true(file.exists(path_join(dir_tmp, "Makefile")))
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'makefile' works with no dir_make, has name_make", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  setwd(dir_tmp)
  dir.create("src")
  writeLines("cmd_assign(.data = 'data/mydata.csv', use_log = FALSE, .out = 'out/cleaned.rds')",
             con = "src/script.R")
  suppressMessages(ans_obtained <- makefile(path_files = "src", name_make = "Make"))
  ans_expected <- paste0("\n",
                         ".PHONY: all\n",
                         "all:\n",
                         "\n\n",
                         "out/cleaned.rds: ", "src/script.R", " \\\n",
                         "  data/mydata.csv\n",
                         "\t", "Rscript $^ $@ --use_log=FALSE\n",
                         "\n\n",
                         ".PHONY: clean\n",
                         "clean:\n",
                         "\trm -rf out\n",
                         "\tmkdir out\n\n")
  expect_identical(ans_obtained, ans_expected)
  expect_true(file.exists("Make"))
  unlink(dir_tmp, recursive = TRUE)
  setwd(dir_curr)
})

test_that("'makefile' works with no dir_make, no path_files", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  setwd(dir_tmp)
  dir.create("src")
  suppressMessages(ans_obtained <- makefile())
  ans_expected <- paste0("\n",
                         ".PHONY: all\n",
                         "all:\n\n\n",
                         ".PHONY: clean\n",
                         "clean:\n",
                         "\trm -rf out\n",
                         "\tmkdir out\n\n")
  expect_identical(ans_obtained, ans_expected)
  expect_true(file.exists(path_join(dir_tmp, "Makefile")))
  unlink(dir_tmp, recursive = TRUE)
  setwd(dir_curr)
})

test_that("'makefile' throws appropriate error when file already exists", {
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  dir.create(path_join(dir_tmp, "src"))
  file_path <- path_join(dir_tmp, "src/script.R")
  writeLines("cmd_assign(.data = 'data/mydata.csv', use_log = FALSE, .out = 'out/cleaned.rds')",
             con = file_path)
  writeLines("bla",
             con = path_join(dir_tmp, "Makefile"))
  expect_error(suppressMessages(makefile(path_files = "src", dir_make = dir_tmp)),
               "already contains a file called")
  suppressMessages(makefile(path_files = "src", dir_make = dir_tmp, overwrite = TRUE))
  ans <- readLines(path_join(dir_tmp, "Makefile"))
  expect_identical(ans[[2]], ".PHONY: all")
  unlink(dir_tmp, recursive = TRUE)
})

## 'shell_script' -------------------------------------------------------------

test_that("'shell_script' works with has dir_shell, no name_shell", {
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  dir.create(path_join(dir_tmp, "src"))
  file_path <- path_join(dir_tmp, "src/script.R")
  writeLines("cmd_assign(.data = 'data/mydata.csv', use_log = FALSE, .out = 'out/cleaned.rds')",
             con = file_path)
  suppressMessages(ans_obtained <- shell_script(path_files = "src", dir_shell = dir_tmp))
  ans_expected <- paste0("\n",
                         "Rscript src/script.R \\\n",
                         "  data/mydata.csv \\\n",
                         "  out/cleaned.rds \\\n",
                         "  --use_log=FALSE\n\n")
  expect_identical(ans_obtained, ans_expected)
  expect_true(file.exists(path_join(dir_tmp, "workflow.sh")))
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'shell_script' works with no dir_shell, has name_shell", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  setwd(dir_tmp)
  dir.create("src")
  writeLines("cmd_assign(.data = 'data/mydata.csv', use_log = FALSE, .out = 'out/cleaned.rds')",
             con = "src/script.R")
  suppressMessages(ans_obtained <- shell_script(path_files = "src", name_shell = "shell"))
  ans_expected <- paste0("\n",
                         "Rscript src/script.R \\\n",
                         "  data/mydata.csv \\\n",
                         "  out/cleaned.rds \\\n",
                         "  --use_log=FALSE\n\n")
  expect_identical(ans_obtained, ans_expected)
  expect_true(file.exists("shell"))
  unlink(dir_tmp, recursive = TRUE)
  setwd(dir_curr)
})

test_that("'shell_script' throws error with no path_files", {
  expect_error(shell_script(),
               "argument \"path_files\" is missing, with no default")
})

test_that("'shell_script' throws appropriate error when file already exists", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  setwd(dir_tmp)
  dir.create("src")
  writeLines("cmd_assign(.data = 'data/mydata.csv', use_log = FALSE, .out = 'out/cleaned.rds')",
             con = "src/script.R")
  writeLines("bla",
             con = "shell.sh")
  expect_error(suppressMessages(shell_script(path_files = "src", name_shell = "shell.sh")),
               "already contains a")
  suppressMessages(shell_script(path_files = "src", name_shell = "shell.sh", overwrite = TRUE))
  ans <- readLines("shell.sh")
  expect_identical(ans[[2]], "Rscript src/script.R \\")
  unlink(dir_tmp, recursive = TRUE)
  setwd(dir_curr)
})

## 'cmd_assign' ---------------------------------------------------------------

test_that("'cmd_assign' works with valid arguments - on command line", {
    dir_curr <- getwd()
    dir_tmp <- tempfile(tmpdir = getwd())
    if (file.exists(dir_tmp))
        unlink(dir_tmp, recursive = TRUE)
    dir.create(dir_tmp)
    setwd(dir_tmp)
    writeLines(c("command::cmd_assign(p_file1 = 'myfile.xsls', obj = 'obj.rds', n = 2L, named = 'goodbye')",
                 "saveRDS(p_file1, file = 'p_file1.rds')",
                 "saveRDS(obj, file = 'obj.rds')",
                 "saveRDS(n, file = 'n.rds')",
                 "saveRDS(named, file = 'named.rds')",
                 "saveRDS(ls(), file = 'ls.rds')"),
               con = "script.R")
    cmd <- sprintf("%s/bin/Rscript script.R thatfile.xlsx obj.rds -n=1 --named=hello",
                   R.home())
    system(cmd, ignore.stderr = TRUE)
    p_file1 <- readRDS("p_file1.rds")
    expect_identical(p_file1, "thatfile.xlsx")
    obj <- readRDS("obj.rds")
    expect_identical(obj, "obj.rds")
    n <- readRDS("n.rds")
    expect_identical(n, 1L)
    named <- readRDS("named.rds")
    expect_identical(named, "hello")
    ls <- readRDS("ls.rds")
    expect_setequal(ls, c("p_file1", "obj", "n", "named"))
    setwd(dir_curr)
    unlink(dir_tmp, recursive = TRUE)
})

test_that("'cmd_assign' works with valid arguments - interactively", {
  if (interactive()) {
    suppressMessages(
      cmd_assign(obj = "obj.rds", n = 2, named = 'goodbye')
    )
    expect_identical(obj, "obj.rds")
    expect_identical(n, 2)
    expect_identical(named, "goodbye")
    expect_setequal(ls(), c("obj", "n", "named"))
  }
  else
    expect_true(TRUE)
})

test_that("'cmd_assign' works with on command line with options passed before file argument", {
    dir_curr <- getwd()
    dir_tmp <- tempfile(tmpdir = getwd())
    if (file.exists(dir_tmp))
        unlink(dir_tmp, recursive = TRUE)
    dir.create(dir_tmp)
    setwd(dir_tmp)
    writeLines(c("command::cmd_assign(p_file1 = 'myfile.xsls', obj = 'obj.rds', n = 2L, named = 'goodbye')",
                 "saveRDS(p_file1, file = 'p_file1.rds')",
                 "saveRDS(obj, file = 'obj.rds')",
                 "saveRDS(n, file = 'n.rds')",
                 "saveRDS(named, file = 'named.rds')",
                 "saveRDS(ls(), file = 'ls.rds')"),
               con = "script.R")
    cmd <- sprintf(paste("%s/bin/Rscript --default-packages=methods,datasets --verbose",
                         "script.R thatfile.xlsx obj.rds -n=1 --named=hello"),
                   R.home())
    system(cmd, ignore.stderr = TRUE)
    p_file1 <- readRDS("p_file1.rds")
    expect_identical(p_file1, "thatfile.xlsx")
    obj <- readRDS("obj.rds")
    expect_identical(obj, "obj.rds")
    n <- readRDS("n.rds")
    expect_identical(n, 1L)
    named <- readRDS("named.rds")
    expect_identical(named, "hello")
    ls <- readRDS("ls.rds")
    expect_setequal(ls, c("p_file1", "obj", "n", "named"))
    setwd(dir_curr)
    unlink(dir_tmp, recursive = TRUE)
})

test_that("'cmd_assign' works with valid arguments - on command line, with littler (if available)", {
  skip_if_no_littler_available()
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  setwd(dir_tmp)
  writeLines(c("command::cmd_assign(p_file1 = 'myfile.xsls', obj = 'obj.rds', n = 2L, named = 'goodbye')",
               "saveRDS(p_file1, file = 'p_file1.rds')",
               "saveRDS(obj, file = 'obj.rds')",
               "saveRDS(n, file = 'n.rds')",
               "saveRDS(named, file = 'named.rds')",
               "saveRDS(ls(), file = 'ls.rds')"),
             con = "script.R")
  cmd <- "lr script.R thatfile.xlsx obj.rds -n=1 --named=hello"
  system(cmd, ignore.stderr = TRUE)
  p_file1 <- readRDS("p_file1.rds")
  expect_identical(p_file1, "thatfile.xlsx")
  obj <- readRDS("obj.rds")
  expect_identical(obj, "obj.rds")
  n <- readRDS("n.rds")
  expect_identical(n, 1L)
  named <- readRDS("named.rds")
  expect_identical(named, "hello")
  ls <- readRDS("ls.rds")
  expect_setequal(ls, c("p_file1", "obj", "n", "named", "argv"))
  setwd(dir_curr)
  unlink(dir_tmp, recursive = TRUE)
})



## 'cmd_assign_quiet' ---------------------------------------------------------

test_that("'cmd_assign_quiet' works with valid arguments - on command line", {
    dir_curr <- getwd()
    dir_tmp <- tempfile(tmpdir = getwd())
    if (file.exists(dir_tmp))
        unlink(dir_tmp, recursive = TRUE)
    dir.create(dir_tmp)
    setwd(dir_tmp)
    writeLines(c("command::cmd_assign_quiet(p_file1 = 'myfile.xsls', obj = 'obj.rds', n = 2L, named = 'goodbye')",
                 "saveRDS(p_file1, file = 'p_file1.rds')",
                 "saveRDS(obj, file = 'obj.rds')",
                 "saveRDS(n, file = 'n.rds')",
                 "saveRDS(named, file = 'named.rds')",
                 "saveRDS(ls(), file = 'ls.rds')"),
               con = "script.R")
    cmd <- sprintf("%s/bin/Rscript script.R thatfile.xlsx obj.rds -n=1 --named=hello",
                   R.home())
    system(cmd, ignore.stderr = TRUE)
    p_file1 <- readRDS("p_file1.rds")
    expect_identical(p_file1, "thatfile.xlsx")
    obj <- readRDS("obj.rds")
    expect_identical(obj, "obj.rds")
    n <- readRDS("n.rds")
    expect_identical(n, 1L)
    named <- readRDS("named.rds")
    expect_identical(named, "hello")
    ls <- readRDS("ls.rds")
    expect_setequal(ls, c("p_file1", "obj", "n", "named"))
    setwd(dir_curr)
    unlink(dir_tmp, recursive = TRUE)
})

test_that("'cmd_assign_quiet' works with valid arguments - interactively", {
  if (interactive()) {
    cmd_assign_quiet(obj = "obj.rds", n = 2, named = 'goodbye')
    expect_identical(obj, "obj.rds")
    expect_identical(n, 2)
    expect_identical(named, "goodbye")
    expect_setequal(ls(), c("obj", "n", "named"))
  }
  else
    expect_true(TRUE)
})

test_that("'cmd_assign_quiet' works with on command line with options passed before file argument", {
    dir_curr <- getwd()
    dir_tmp <- tempfile(tmpdir = getwd())
    if (file.exists(dir_tmp))
        unlink(dir_tmp, recursive = TRUE)
    dir.create(dir_tmp)
    setwd(dir_tmp)
    writeLines(c("command::cmd_assign_quiet(p_file1 = 'myfile.xsls', obj = 'obj.rds', n = 2L, named = 'goodbye')",
                 "saveRDS(p_file1, file = 'p_file1.rds')",
                 "saveRDS(obj, file = 'obj.rds')",
                 "saveRDS(n, file = 'n.rds')",
                 "saveRDS(named, file = 'named.rds')",
                 "saveRDS(ls(), file = 'ls.rds')"),
               con = "script.R")
    cmd <- sprintf(paste("%s/bin/Rscript --default-packages=methods,datasets --verbose",
                         "script.R thatfile.xlsx obj.rds -n=1 --named=hello"),
                   R.home())
    system(cmd, ignore.stderr = TRUE)
    p_file1 <- readRDS("p_file1.rds")
    expect_identical(p_file1, "thatfile.xlsx")
    obj <- readRDS("obj.rds")
    expect_identical(obj, "obj.rds")
    n <- readRDS("n.rds")
    expect_identical(n, 1L)
    named <- readRDS("named.rds")
    expect_identical(named, "hello")
    ls <- readRDS("ls.rds")
    expect_setequal(ls, c("p_file1", "obj", "n", "named"))
    setwd(dir_curr)
    unlink(dir_tmp, recursive = TRUE)
})

test_that("'cmd_assign_quiet' works with valid arguments - on command line, with littler (if available)", {
  skip_if_no_littler_available()
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  setwd(dir_tmp)
  writeLines(c("command::cmd_assign_quiet(p_file1 = 'myfile.xsls', obj = 'obj.rds', n = 2L, named = 'goodbye')",
               "saveRDS(p_file1, file = 'p_file1.rds')",
               "saveRDS(obj, file = 'obj.rds')",
               "saveRDS(n, file = 'n.rds')",
               "saveRDS(named, file = 'named.rds')",
               "saveRDS(ls(), file = 'ls.rds')"),
             con = "script.R")
  cmd <- "lr script.R thatfile.xlsx obj.rds -n=1 --named=hello"
  system(cmd, ignore.stderr = TRUE)
  p_file1 <- readRDS("p_file1.rds")
  expect_identical(p_file1, "thatfile.xlsx")
  obj <- readRDS("obj.rds")
  expect_identical(obj, "obj.rds")
  n <- readRDS("n.rds")
  expect_identical(n, 1L)
  named <- readRDS("named.rds")
  expect_identical(named, "hello")
  ls <- readRDS("ls.rds")
  expect_setequal(ls, c("p_file1", "obj", "n", "named", "argv"))
  setwd(dir_curr)
  unlink(dir_tmp, recursive = TRUE)
})


## Empty named value from Make: --v=$(V) with V undefined → --v=
## The empty value still counts as an argument, so arity checks pass.
test_that("'cmd_assign' with --v= (empty Make variable) and character default", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  setwd(dir_tmp)
  writeLines(c("command::cmd_assign(.data = 'in.csv', v = 'default', .out = 'out.rds')",
               "saveRDS(list(.data = .data, v = v, .out = .out), file = 'result.rds')"),
             con = "script.R")
  cmd <- sprintf("%s/bin/Rscript script.R in.csv out.rds --v=", R.home())
  status <- system(cmd, ignore.stderr = TRUE)
  expect_identical(status, 0L)
  result <- readRDS("result.rds")
  ## Currently: empty string is accepted for character v.
  expect_identical(result$v, "")
  expect_identical(result$.data, "in.csv")
  expect_identical(result$.out, "out.rds")
  setwd(dir_curr)
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'cmd_assign' with --v= (empty Make variable) and integer default", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  setwd(dir_tmp)
  writeLines(c("command::cmd_assign(.data = 'in.csv', v = 1L, .out = 'out.rds')",
               "saveRDS(list(.data = .data, v = v, .out = .out), file = 'result.rds')"),
             con = "script.R")
  cmd <- sprintf("%s/bin/Rscript script.R in.csv out.rds --v=", R.home())
  status <- system(cmd, ignore.stderr = TRUE)
  expect_false(identical(status, 0L))
  expect_false(file.exists("result.rds"))
  setwd(dir_curr)
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'cmd_assign' with --v= (empty Make variable) and logical default", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  setwd(dir_tmp)
  writeLines(c("command::cmd_assign(.data = 'in.csv', v = TRUE, .out = 'out.rds')",
               "saveRDS(list(.data = .data, v = v, .out = .out), file = 'result.rds')"),
             con = "script.R")
  cmd <- sprintf("%s/bin/Rscript script.R in.csv out.rds --v=", R.home())
  status <- system(cmd, ignore.stderr = TRUE)
  expect_false(identical(status, 0L))
  expect_false(file.exists("result.rds"))
  setwd(dir_curr)
  unlink(dir_tmp, recursive = TRUE)
})

## HAS_TESTS
#' Turn a 'cmd_assign' Call Into a Makefile Rule
#'
#' Extract a call to [cmd_assign()] from an
#' R script, and turn it into a Makefile rule.
#'
#' # The components of a Makefile rule
#'
#' A Makefile rule produced by `extract_make()`
#' normally looks something like this:
#' ```
#' out/model.rds: src/model.R \
#'   data/cleaned.rds
#'        Rscript $^ $@ --use_log=TRUE
#' ```
#'
#' In this rule
#' - `out/model.rds` is the "target", i.e. the file that the rule creates;
#' - `src/model.R` and `data/timeseries.rds` are "prerequisites",
#'   i.e. files that are used to create the target;
#' - `\` is a "line continuation character";
#' - `        ` at the start of the third line is a tab,
#'   telling `make` that the recipe for creating the target from
#'   the starts here;
#' - `Rscript` is a call to [utils::Rscript()];
#' - `$^` is an [automatic variable](https://www.gnu.org/software/make/manual/make.html#Automatic-Variables)
#'   meaning "all the prerequisites"
#'   and `$@` is an automatic variable meaning "the target",
#'   so that `Rscript $^ $@` expands to
#'   `Rscript src/model.R data/cleaned.rds out/model.rds`; and
#' - `--use_log=TRUE` is a named argument that
#'   Rscript passes to `src/model.R`
#'
#'
#' # Using `extract_make()` to build a data analysis workflow
#'
#' - Step 1. Write the R file that carries out
#'   the step in analysis (eg tidying data, fitting
#'   a model, making a graph.) This file
#'   will contain a call to [cmd_assign()],
#'   and  will appear in the first line of the
#'   Makefile rule. When writing and testing the file,
#'   use [cmd_assign()] interactively.
#' - Step 2. Once the R file is working correctly,
#'   call `extract_make()`, and add the rule
#'   to your Makefile.
#'
#' When using `extract_make()`, it is a good idea to
#' set the current working directory to the project
#' directory (something that will happen automatically
#' if you are using RStudio projects.)
#'
#' # Location of the Makefile
#'
#' The Makefile normally sets at the top of
#' the project, so that the
#' project folder looks something like this:
#' ```
#' Makefile
#' - data/
#' - src/
#' - out/
#' report.qmd
#' ```
#' 
#' # Identifying file arguments
#'
#' To construct the Makefile rule, `extract_make()` needs to
#' be able to pick out arguments that refer to
#' file names. To do so, it uses the following heuristic:
#' - if the call includes arguments whose names start with
#'   a dot, then these arguments are assumed to
#'   refer to file names;
#' - otherwise, find arguments whose values
#'   actually are file names
#'   (as determined by [file.exists()]), or that look
#'   like they could be.
#' 
#' @param path_file A path from
#' `dir_make` to the R scripe containing
#' the call to [cmd_assign()]. 
#' @param dir_make The directory that contains
#' the Makefile. The default is
#' the current working directory.
#'
#' @returns `extract_make()` is typically called
#' for its side effect, which is to print a
#' Makefile rule. However, `extract_make()`
#' invisibly returns a text string with the rule.
#'
#' @seealso
#' - [extract_shell()] Shell script equivalent of `extract_make()`
#' - [makefile()] Create a Makefile
#'   from calls to [cmd_assign()]
#' - [cmd_assign()] Process command line arguments
#' - [Quick Start](https://bayesiandemography.github.io/command/articles/quickstart.html)
#'   How to use `cmd_assign()`
#' - [Modular Workflows for Data Analysis](https://bayesiandemography.github.io/command/articles/workflow.html)
#'   Safe, flexible data analysis workflows
#' - [littler](https://CRAN.R-project.org/package=littler) Alternative to Rscript
#'
#' @references
#' - [Project Management with Make](https://jeroenjanssens.com/dsatcl/chapter-6-project-management-with-make)
#'   Makefiles in data analysis workflows
#' - [GNU make](https://www.gnu.org/software/make/manual/make.html#SEC_Contents)
#'   Definitive guide
#' - [Command-Line Programs](https://swcarpentry.github.io/r-novice-inflammation/05-cmdline.html)
#'   Introduction to Rscript
#'
#' @examples
#' library(withr)
#' with_tempdir({
#'
#'   ## create 'src'  directory
#'   dir.create("src")
#'
#'   ## put an R script containing a call to
#'   ## 'cmd_assign' in the 'src' directory
#'   writeLines(c("cmd_assign(x = 1, .out = 'out/results.rds')",
#'                "results <- x + 1",
#'                "saveRDS(results, file = .out)"),
#'              con = "src/results.R")
#'
#'   ## call 'extract_make()'
#'   extract_make(path_file = "src/results.R",
#'                dir_make = ".")
#'
#' })
#' @export
extract_make <- function(path_file, dir_make = NULL) {
  has_dir_arg <- !is.null(dir_make)
  if (has_dir_arg)
    check_dir(dir = dir_make,
              nm = "dir_make")
  else
    dir_make <- "."
  check_path_file_valid(path_file = path_file,
                        dir = dir_make,
                        nm_dir_arg = "dir_make",
                        has_dir_arg = has_dir_arg)
  path_file_comb <- path_join(dir_make, path_file)
  check_is_r_code(path_file_comb)
  args <- extract_args(path_file_comb)
  ans <- format_args_make(file = path_file_comb,
                          args = args)
  cat(ans)
  invisible(ans)
}

#' Create a Shell Script
#'
#' Create a shell script for a data analysis workflow
#' consisting of commands
#' extracted from existing R files.
#'
#' To create a shell script in the `files`
#' directory, set `files` to `"."`.
#'
#' To obtain the contents of the shell script
#' without creating a file on disk,
#' creating the file on disk, set
#' `name_shell` to `NULL`.
#'
#' Supplying a value for `files` is
#' compulsory for `shell_script()`,
#' but optional for [makefile()].
#' The output from `shell_script()`
#' is generated entirely from `files`
#' while the output from [makefile()]
#' also includes some general-purpose Makefile
#' commands.
#'
#' @param path_files A path from `dir_shell` to a
#' directory with R scripts containing
#' calls to [cmd_assign()].
#' @param dir_shell The directory where
#' `shell_script()` will create the shell script.
#' If no value is supplied, then `shell_script()`
#' creates the shell script in the current working directory.
#' @param name_shell The name of the shell script.
#' The default is `"workflow.sh"`.
#' @param overwrite Whether to overwrite
#' an existing shell script. Default is `FALSE`.
#' @param quiet Whether to suppress
#' progress messages. Default is `FALSE`.
#' 
#' @returns `shell_script()` is called for its
#' side effect, which is to create a
#' file. However, `shell_script()` also
#' returns a string with the contents of the
#' shell script.
#'
#' @seealso
#' - [Creating a Shell Script](https://bayesiandemography.github.io/command/articles/a2_shell_script.html) More on `shell_script()`
#' - [extract_shell()] Turn a [cmd_assign()] call into a shell command
#' - [makefile()] Makefile equivalent of `shell_script()`
#' - [cmd_assign()] Process command line arguments
#' - [Modular Workflows for Data Analysis](https://bayesiandemography.github.io/command/articles/workflow.html)
#'   Safe, flexible data analysis workflows
#' - [littler](https://CRAN.R-project.org/package=littler) Alternative to Rscript
#'
#' @references
#' - Episodes 1--3 of [The Unix Shell](https://swcarpentry.github.io/shell-novice/index.html)
#'   Introduction to the command line
#' - [Command-Line Programs](https://swcarpentry.github.io/r-novice-inflammation/05-cmdline.html)
#'   Introduction to Rscript
#'
#' @examples
#' library(withr)
#'
#' with_tempdir({
#'
#'   ## create 'src'  directory
#'   dir.create("src")
#'
#'   ## put R scripts containing calls to
#'   ## 'cmd_assign' in the 'src' directory
#'   writeLines(c("cmd_assign(x = 1, .out = 'out/results.rds')",
#'                "results <- x + 1",
#'                "saveRDS(results, file = .out)"),
#'              con = "src/results.R")
#'   writeLines(c("cmd_assign(x = 1, .out = 'out/more_results.rds')",
#'                "more_results <- x + 2",
#'                "saveRDS(more_results, file = .out)"),
#'              con = "src/more_results.R")
#'
#'   ## call 'shell_script()'
#'   shell_script(path_files = "src",
#'                dir_shell = ".")
#'
#'   ## shell script has been created
#'   list.files()
#'
#'   ## print contents of shell script
#'   cat(readLines("workflow.sh"), sep = "\n")
#' 
#' })
#' @export
shell_script <- function(path_files,
                         dir_shell = NULL,
                         name_shell = "workflow.sh",
                         overwrite = FALSE,
                         quiet = FALSE) {
  has_dir_shell <- !is.null(dir_shell)
  if (has_dir_shell)
    check_dir(dir_shell, nm = "dir_shell")
  else
    dir_shell <- "."
  check_path_files_valid(path_files = path_files,
                         dir = dir_shell,
                         nm_dir_arg = "dir_shell",
                         has_dir_arg = has_dir_shell)
  has_name_shell <- !is.null(name_shell)
  if (has_name_shell)
    check_valid_filename(x = name_shell,
                         nm = "name_shell")
  check_flag(x = overwrite,
             nm = "overwrite")
  lines <- ""
  commands <- make_commands(path_files = path_files,
                            dir_shell = dir_shell,
                            quiet = quiet)
  if (length(commands) > 0L)
    lines <- c(lines,
               commands)
  lines <- c(lines,
             "")
  if (has_name_shell) {
    path_shell <- path_join(dir_shell, name_shell)
    if (file.exists(path_shell) && !overwrite)
      cli::cli_abort(c(paste("Directory {.file {dir_shell}} already contains a",
                             "file called {.file {name_shell}}."),
                       i = "To overwrite an existing file, set {.arg overwrite} to {.val {TRUE}}."))
    writeLines(lines, con = path_shell)
  }
  lines <- paste(lines, collapse = "\n")
  invisible(lines)
}



      

               
  

#' command: Process command line arguments
#'
#' Process command line arguments, allowing scripts to
#' behave like functions, with well-defined inputs and outputs.
#' Helps make data analysis workflows more modular,
#' and therefore more transparent, flexible, and reliable.
#'
#' - [cmd_assign()] Process command line arguments
#' - [use_renv()] Activate a renv project before loading packages
#' - [extract_shell()] Turn a `cmd_assign()` call into a shell command
#' - [extract_make()] Turn a `cmd_assign()` call into a Makefile rule
#' - [shell_script()] Create a shell script
#' - [makefile()] Create a Makefile
#' - [Quick Start](https://bayesiandemography.github.io/command/articles/quickstart.html)
#'   How to use `cmd_assign()`
#' - [Modular Workflows for Data Analysis](https://bayesiandemography.github.io/command/articles/workflow.html)
#'   Safe, flexible data analysis workflows
#' - [Using command with renv](https://bayesiandemography.github.io/command/articles/a5_renv.html)
#'   Running pipeline scripts with renv
#' 
#' @docType package
#' @name command-package
#' @aliases command
"_PACKAGE"
utils::globalVariables("argv")
## usethis namespace: start
## usethis namespace: end
NULL

## HAS_TESTS
#' Turn a 'cmd_assign' Call Into a Shell Command
#'
#' Extract a call to [cmd_assign()] from an
#' R script, and turn it into a shell command.
#'
#' # The components of a shell command
#'
#' The shell command produced by `extract_shell()`
#' normally looks something like this:
#' ```
#' Rscript src/model.R \
#'   data/cleaned.rds \
#'   out/model.rds \
#'   --use_log=TRUE
#' ```
#'
#' In this command
#' - `Rscript` is a call to [utils::Rscript()];
#' - `\` is a "line continuation character";
#' - `data/cleaned.rds` and `out/model.rds` are unnamed
#'   arguments that Rscript passes to `src/model.R`; and
#' - `--use_log=TRUE` is a named argument that
#'   Rscript passes to `src/model.R`
#'
#' # Using `extract_shell()` to build a data analysis workflow
#'
#' - Step 1. Write an R script that carries out
#'   a step in analysis (eg tidying data, fitting
#'   a model, making a graph.) This script
#'   will contain a call to [cmd_assign()],
#'   and  will be the first argument passed to
#'   Rscript in the shell command.
#'   When writing and testing the script,
#'   use [cmd_assign()] interactively.
#' - Step 2. Once the R script is working correctly,
#'   call `extract_shell()`, and add the command
#'   to your shell script.
#'
#' # Location of the shell script
#'
#' The shell script normally sits at the
#' top level of the project, so that the
#' project folder looks something like this:
#' ```
#' workflow.sh
#' - data/
#' - src/
#' - out/
#' report.qmd
#' ```
#'
#' # Identifying file arguments
#'
#' To construct the rule, `extract_shell()` needs to
#' be able to identify arguments that refer to a
#' file name. To do so, it uses the following heuristic:
#' - if the call includes arguments whose names start with
#'   a dot, then these arguments are assumed to
#'   refer to file names;
#' - otherwise, find arguments whose values
#'   actually are file names
#'   (as determined by [file.exists()]) or that look
#'   like they could be.
#' 
#' @param path_file Path to the R script containing
#' the call to [cmd_assign()]. The path
#' starts at `dir_shell`.
#' @param dir_shell The directory that contains
#' the shell script. The default is
#' the current working directory.
#'
#' @returns `extract_shell()` is typically called
#' for its side effect, which is to print a
#' shell command. However, `extract_shell()`
#' invisibly returns a text string with the command.
#'
#' @seealso
#' - [extract_make()] Makefile equivalent of `extract_shell()`
#' - [shell_script()] Create a shell script
#'   from calls to [cmd_assign()]
#' - [cmd_assign()] Process command line arguments
#' - [Quick Start](https://bayesiandemography.github.io/command/articles/quickstart.html)
#'   How to use `cmd_assign()`
#' - [Modular Workflows for Data Analysis](https://bayesiandemography.github.io/command/articles/workflow.html)
#'   Safe, flexible data analysis workflows
#'
#' @references
#' - Episodes 1--3 of [The Unix Shell](https://swcarpentry.github.io/shell-novice/index.html)
#'   Introduction to the command line
#' - [Command-Line Programs](https://swcarpentry.github.io/r-novice-inflammation/05-cmdline.html)
#'   Introduction to Rscript
#' - [littler](https://CRAN.R-project.org/package=littler) Alternative to Rscript
#'
#' @examples
#' library(withr)
#' 
#' with_tempdir({
#'
#'   ## create 'src' directory
#'   dir.create("src")
#'
#'   ## add an R script containing a call to 'cmd_assign'
#'   writeLines(c("cmd_assign(x = 1, .out = 'out/results.rds')",
#'                "results <- x + 1",
#'                "saveRDS(results, file = .out)"),
#'              con = "src/results.R")
#'
#'   ## call 'extract_shell()'
#'   extract_shell(path_file = "src/results.R",
#'                 dir_shell = ".")
#'
#' })
#' @export
extract_shell <- function(path_file, dir_shell = NULL) {
  has_dir_arg <- !is.null(dir_shell)
  if (has_dir_arg)
    check_dir(dir = dir_shell,
              nm = "dir_shell")
  else
    dir_shell <- "."
  check_path_file_valid(path_file = path_file,
                        dir = dir_shell,
                        nm_dir_arg = "dir_shell",
                        has_dir_arg = has_dir_arg)
  path_file_comb <- path_join(dir_shell, path_file)
  check_is_r_code(path_file_comb)
  args <- extract_args(path_file_comb)
  ans <- format_args_shell(file = path_file_comb,
                           args = args)
  cat(ans)
  invisible(ans)
}  

## HAS_TESTS
#' Join Path Components with Forward Slashes
#'
#' Base-R stand-in for `fs::path()`, using
#' forward slashes so paths are suitable for
#' Makefiles and shell scripts on all platforms.
#' Components that are `"."` are dropped so that
#' joining with the current directory does not
#' produce a redundant `"./"` prefix.
#'
#' @param ... Path components
#'
#' @returns A character vector of length 1
#'
#' @noRd
path_join <- function(...) {
  parts <- unlist(list(...), use.names = FALSE)
  parts <- parts[nzchar(parts) & parts != "."]
  if (!length(parts))
    return(".")
  paste(parts, collapse = "/")
}


## HAS_TESTS
#' Test Whether a Path is Absolute
#'
#' Base-R stand-in for `fs::is_absolute_path()`.
#' Recognises Unix paths and Windows drive / UNC paths.
#'
#' @param path A length-1 character string
#'
#' @returns TRUE or FALSE
#'
#' @noRd
is_absolute_path <- function(path) {
  grepl("^(/|[A-Za-z]:([/\\\\]|$)|\\\\\\\\)", path)
}


## HAS_TESTS
#' Make Paths Relative to a Start Directory
#'
#' Base-R stand-in for `fs::path_rel()`.
#'
#' @param path Character vector of paths
#' @param start Directory to make paths relative to
#'
#' @returns A character vector the same length as `path`
#'
#' @noRd
path_rel <- function(path, start = ".") {
  path <- normalizePath(path, winslash = "/", mustWork = FALSE)
  start <- normalizePath(start, winslash = "/", mustWork = TRUE)
  prefix <- paste0(start, "/")
  ## Windows paths are case-insensitive; normalizePath() may still
  ## disagree on drive-letter case (e.g. d: vs D: on WinBuilder).
  fold <- if (.Platform$OS.type == "windows") tolower else identity
  ans <- character(length(path))
  for (i in seq_along(path)) {
    p <- path[[i]]
    if (identical(fold(p), fold(start)))
      ans[[i]] <- "."
    else if (startsWith(fold(p), fold(prefix)))
      ans[[i]] <- substring(p, nchar(prefix) + 1L)
    else
      cli::cli_abort("Can't make {.path {path[[i]]}} relative to {.path {start}}.")
  }
  ans
}


## HAS_TESTS
#' Reorder 'args_cmd' and Add Names So That
#' It Aligns With 'args_dots'
#'
#' Use 'args_dots' to name and order elements
#' of 'args_cmd'. The process mimics argument
#' matching in function calls in R, in that
#' elements of 'args_cmd' are matched by name
#' where possible and by position where not.
#'
#' Assume that `args_dots` has been
#' checked via `check_arg_dots()` and
#' `args_cmd` has been checked via
#' `check_args_cmd()`.
#' 
#' @param args_cmd A list, possibly with names.
#' @param args_dots A named list, the same
#' length as `arg_dots`.
#'
#' @return A list with the same length
#' and names as `arg_dots`.
#' 
#' @noRd
align_cmd_to_dots <- function(args_cmd, args_dots) {
  n <- length(args_cmd)
  nms_cmd <- names(args_cmd)
  nms_dots <- names(args_dots)
  if (is.null(nms_cmd))
    is_named <- rep(FALSE, times = n)
  else
    is_named <- nzchar(nms_cmd)
  args_cmd_named <- args_cmd[is_named]
  args_cmd_unnamed <- args_cmd[!is_named]
  nms_cmd_named <- nms_cmd[is_named]
  i_unnamed <- 1L
  ans <- vector(mode = "list", length = n)
  for (i in seq_len(n)) {
    nm_dots <- nms_dots[[i]]
    i_named <- match(nm_dots, nms_cmd_named, nomatch = 0L)
    if (i_named > 0L)
      ans[[i]] <- args_cmd_named[[i_named]]
    else {
      ans[[i]] <- args_cmd_unnamed[[i_unnamed]]
      i_unnamed <- i_unnamed + 1L
    }
  }
  names(ans) <- nms_dots
  ans
}


## HAS_TESTS
#' Create Objects in the Specified Environment
#'
#' Use the names and values in 'args' to create
#' objects in environment 'envir'.
#'
#' @param args A named list.
#' @param envir The environment where the
#' objects are to be created.
#' @param quiet Flag. If `TRUE`, suppress
#' success message.
#'
#' @return Returns 'args' invisibly,
#' and creates objects as a side effect.
#'
#' @noRd
assign_args <- function(args, envir, quiet) {
  nms <- names(args)
  for (i in seq_along(args)) {
    arg <- args[[i]]
    nm <- nms[[i]]
    assign(x = nm,
           value = arg,
           envir = envir)
    assigned <- cli::col_grey("Assigned object")
    nm <- sprintf("`%s`", nm)
    nm <- cli::col_blue(nm)
    value <- cli::col_grey("with value")
    class <- cli::col_grey("and class")
    empty <- if (identical(arg, "")) " (an empty string)" else ""
    if (!quiet) {
      cli::cli_alert_success("{assigned} {nm} {value} {.val {arg}}{empty} {class} {.val {class(arg)}}.")
    }
  }
  invisible(args)
}    


## HAS_TESTS
#' Internal Version of 'extract_shell' that Returns
#' Text Where Possible and NULL Otherwise
#'
#' @param file Path to R file from 'dir_shell'
#' @param dir_shell Directory where the
#' shell script is
#' @param quiet Flag. Success message
#' only printed if 'quiet' is FALSE
#'
#' @returns A text string or NULL
#'
#' @noRd
extract_shell_if_possible <- function(file, dir_shell, quiet) {
  path_file <- path_join(dir_shell, file)
  ext <- tools::file_ext(path_file)
  if (!ext %in% c("r", "R"))
    return(NULL)
  text <- paste(readLines(path_file), collapse = "\n")
  exprs <- parse(text = text)
  nm_cmd <- as.name("cmd_assign")
  for (expr in exprs) {
    nm_expr <- expr[[1L]]
    if (is.call(expr) && identical(nm_expr, nm_cmd)) {
      args <- as.list(expr)[-1L]
      args <- lapply(args, eval)
      tryCatch(
        check_args_dots(args),
        error = function(e)
          cli::cli_abort(c(paste("Problem extracting call to {.fun cmd_assign}",
                                 "in file {.file {file}}."),
                           i = "Call to {.fun cmd_assign} malformed?",
                           i = e$message))
      )
      ans <- format_args_shell(file = file, args = args)
      if (!quiet)
        cli::cli_alert_success("Extracted call to {.fun cmd_assign} in {.file {file}}.")
      return(ans)
    }
  }
  NULL
}


## HAS_TESTS
#' Internal Version of 'extract_make' that Returns
#' Text Where Possible and NULL Otherwise
#'
#' @param file Path to R file from 'dir_make'
#' @param dir_make Directory where the
#' Makefile is
#' @param quiet Flag. Success message
#' only printed if 'quiet' is FALSE
#'
#' @returns A text string or NULL
#'
#' @noRd
extract_make_if_possible <- function(file, dir_make, quiet) {
  path_file <- path_join(dir_make, file)
  ext <- tools::file_ext(path_file)
  if (!ext %in% c("r", "R"))
    return(NULL)
  text <- paste(readLines(path_file), collapse = "\n")
  exprs <- parse(text = text)
  nm_cmd <- as.name("cmd_assign")
  for (expr in exprs) {
    nm_expr <- expr[[1L]]
    if (is.call(expr) && identical(nm_expr, nm_cmd)) {
      args <- as.list(expr)[-1L]
      args <- lapply(args, eval)
      tryCatch(
        check_args_dots(args),
        error = function(e)
          cli::cli_abort(c(paste("Problem extracting call to {.fun cmd_assign}",
                                 "in file {.file {file}}."),
                           i = "Call to {.fun cmd_assign} malformed?",
                           i = e$message))
      )
      ans <- format_args_make(file = file, args = args)
      if (!quiet)
        cli::cli_alert_success("Extracted call to {.fun cmd_assign} in {.file {file}}.")
      return(ans)
    }
  }
  NULL
}


## HAS_TESTS
#' Coerce a Single Value Supplied at Command Line to the
#' Class of the Corresponding Value from Dots
#'
#' @param arg_cmd Value supplied at command line
#' @param arg_dots Corresponding value from dots
#' @param nm_cmd Name supplied at command line, or blank if none supplied
#' @param nm_dots Name supplied in call to cmd_assign()
#'
#' @returns Coerced version of `arg_cmd`
#'
#' @noRd
coerce_arg_cmd <- function(arg_cmd, arg_dots, nm_cmd, nm_dots) {
  ## Empty values (e.g. Make expands --v=$(V) to --v= when V is
  ## undefined) are allowed for character arguments, but not for
  ## other classes, where they are almost always a mistake.
  if (!is.character(arg_dots) && identical(arg_cmd, "")) {
    cli::cli_abort(c("Empty value passed at command line for argument {.arg {nm_dots}}.",
                     i = "Value specified by {.fun cmd_assign}: {.val {arg_dots}}.",
                     i = "Class specified by {.fun cmd_assign}: {.cls {class(arg_dots)}}.",
                     i = paste("Empty values are only allowed when {.fun cmd_assign}",
                               "specifies a character argument."),
                     i = paste("If this came from a Makefile, check that the Make",
                               "variable in {.code --{nm_dots}=$(...)} is defined.")))
  }
  if (is.character(arg_dots))
    ans <- arg_cmd
  else if (is.integer(arg_dots))
    ans <- tryCatch(as.integer(arg_cmd),
                    error = function (e) e,
                    warning = function(w) w)
  else if (is.numeric(arg_dots))
    ans <- tryCatch(as.numeric(arg_cmd),
                    error = function (e) e,
                    warning = function(w) w)
  else if (is.logical(arg_dots))
    ans <- tryCatch(as.logical(arg_cmd),
                    error = function (e) e,
                    warning = function(w) w)
  else if (methods::is(arg_dots, "Date"))
    ans <- tryCatch(as.Date(arg_cmd),
                    error = function (e) e,
                    warning = function(w) w)
  else if (methods::is(arg_dots, "POSIXct")) {
    tz <- attr(arg_dots, "tzone")
    ans <- tryCatch(as.POSIXct(arg_cmd, tz = tz),
                    error = function (e) e,
                    warning = function(w) w)
  }
  else if (methods::is(arg_dots, "POSIXlt")) {
    tz <- attr(arg_dots, "tzone")
    ans <- tryCatch(as.POSIXlt(arg_cmd, tz = tz),
                    error = function (e) e,
                    warning = function(w) w)
  }
  else if (is.null(arg_dots))
    ans <- if (identical(arg_cmd, "NULL")) NULL else tryCatch(stop(), error = function(e) e)
  else {
    cli::cli_abort("Internal error: {.arg arg_dots} has class {.cls {class(arg_dots)}}.")
  }
  if (inherits(ans, "error") || inherits(ans, "warning")) {
    cli::cli_abort(c(paste("Can't coerce value passed at command line to class",
                           "specified by {.fun cmd_assign}."),
                     i = "Value passed at command line: {.val {arg_cmd}}.",
                     i = "Value specified by {.fun cmd_assign}: {.val {arg_dots}}.",
                     i = "Name of value specified by {.fun cmd_assign}: {.val {nm_dots}}.",
                     i = "Class of value specified by {.fun cmd_assign}: {.val {class(arg_dots)}}."))
  }
  ans
}
    

## HAS_TESTS
#' Coerce Values Supplied at Command Line
#' to Classes Used in Dots
#'
#' Coerce each element of 'args_cmd' to have
#' the same class as the corresponding
#' element of 'args_dots'. Raise an error
#' if this cannot be done.
#'
#' @param args_cmd Named list of values passed from
#' command line.
#' @param args_dots Named list of values specified
#' via the dots argument of [cmd_assign()].
#'
#' @return Revised version of `args_cmd`.
#'
#' @noRd
coerce_to_dots_class <- function(args_cmd, args_dots) {
  nms_cmd <- names(args_cmd)
  nms_dots <- names(args_dots)
  ans <- .mapply(coerce_arg_cmd,
                 dots = list(arg_cmd = args_cmd,
                             arg_dots = args_dots,
                             nm_cmd = nms_cmd,
                             nm_dots = nms_dots),
                 MoreArgs = list())
  names(ans) <- nms_dots
  ans
}            


## HAS_TESTS
#' Extract Arguments From 'cmd_assign()' Call in File
#'
#' @param File path for an R script with a call to `cmd_assign()`
#'
#' @returns A named list, or NULL
#'
#' @noRd
extract_args <- function(file) {
  code <- paste(readLines(file), collapse = "\n")
  exprs <- parse(text = code)
  nm_cmd <- as.name("cmd_assign")
  for (expr in exprs) {
    nm_expr <- expr[[1L]]
    if (is.call(expr) && identical(nm_expr, nm_cmd)) {
      ans <- as.list(expr)[-1L]
      ans <- lapply(ans, eval)
      return(ans)
    }
  }
  cli::cli_alert_warning("No call to {.fn cmd_assign} found.")
  NULL
}


## HAS_TESTS
#' Turn List of Arguments into a Makefile Rule
#'
#' @param file File path from Makefile to script with R code
#' @param args Named list obtained from call to `cmd_assign()`
#'
#' @returns A string
#'
#' @noRd
format_args_make <- function(file, args) {
  n_space <- 2L
  n_tab <- 8L
  is_file_arg <- is_file_arg(args)
  args <- lapply(args, as.character)
  n_file_arg <- sum(is_file_arg)
  if (identical(n_file_arg, 0L))
    cli::cli_abort(c("Can't find any file arguments.",
                     i = "Nothing to use as a target in Makefile rule."))
  args_is_file <- args[is_file_arg]
  target <- args_is_file[[n_file_arg]]
  ans <- sprintf("%s: %s", target, file)
  if (sum(is_file_arg) > 1L) {
    args_is_file <- args_is_file[-n_file_arg]
    space_left <- strrep(" ", times = n_space)
    args_is_file <- paste0(space_left, args_is_file)
    args_is_file <- paste0(" \\\n", args_is_file)
    ans_is_file <- paste(args_is_file, collapse = "")
    ans <- paste0(ans, ans_is_file)
  }
  ans_recipe <- "\n\tRscript $^ $@"
  ans <- paste0(ans, ans_recipe)
  if (any(!is_file_arg)) {
    args_not_file <- args[!is_file_arg]
    nms_not_file <- names(args_not_file)
    args_not_file <- paste0("--", nms_not_file, "=", args_not_file)
    space_not_file <- strrep(" ", times = n_tab + nchar(ans_recipe) - 1L)
    collapse <- paste0(" \\\n", space_not_file)
    ans_not_file <- paste0(args_not_file, collapse = collapse)
    ans <- paste(ans, ans_not_file)
  }
  ans <- paste0(ans, "\n")
  ans
}


## HAS_TESTS
#' Turn a List or Arguments into a Shell Command
#'
#' @param file File path to R script
#' @param args Named list or arguments from call to `cmd_assign()`
#'
#' @returns A string
#'
#' @noRd
format_args_shell <- function(file, args) {
  n_space <- 2L
  ans <- paste("Rscript", file)
  if (length(args) > 0L) {
    nms <- names(args)
    space_left <- strrep(" ", times = n_space)
    is_file_arg <- is_file_arg(args)
    args <- lapply(args, as.character)
    if (any(is_file_arg)) {
      args_is_file <- args[is_file_arg]
      args_is_file <- paste0(space_left, args_is_file)
      args_is_file <- paste0(" \\\n", args_is_file)
      ans_is_file <- paste(args_is_file, collapse = "")
      ans <- paste0(ans, ans_is_file)
    }
    if (any(!is_file_arg)) {
      args_not_file <- args[!is_file_arg]
      nms_not_file <- names(args_not_file)
      args_not_file <- paste0(space_left, "--", nms_not_file, "=", args_not_file)
      args_not_file <- paste0(" \\\n", args_not_file)
      ans_not_file <- paste(args_not_file, collapse = "")
      ans <- paste0(ans, ans_not_file)
    }
  }
  ans <- paste0(ans, "\n")
  ans
}


## HAS_TESTS
#' Get command line arguments
#'
#' Use function 'commandArgs' to get
#' command line arguments. Assumes
#' that current session is not interactive.
#'
#' @return A named list.
#'
#' @noRd
get_args_cmd <- function() {
  p <- "^-{1,2}(.*)=(.*)$"
  is_littler <- (exists("argv", inherits = FALSE)
    || identical(commandArgs()[[1L]], "littler"))
  if (is_littler)
    args <- argv
  else
    args <- commandArgs(trailingOnly = TRUE)
  if (length(args) == 0L)
    return(list())
  is_named <- grepl(p, args)
  args_named <- args[is_named]
  nms_named <- sub(p, "\\1", args_named)
  vals_named <- sub(p, "\\2", args_named)
  ans <- as.list(args)
  nms_ans <- rep("", times = length(ans))
  nms_ans[is_named] <- nms_named
  names(ans) <- nms_ans
  ans[is_named] <- vals_named
  ans
}


## HAS_TESTS
#' Test Whether an Argument is a File Path
#'
#' Can be actual file path, or a valid potential file path.
#'
#' @param arg Value that might be a file path
#'
#' @returns TRUE or FALSE
#'
#' @noRd
is_actual_or_potential_file_path <- function(arg) {
  if (!is.character(arg) || is.na(arg))
    return(FALSE)
  if (file.exists(arg))
    return(TRUE)
  looks_like_file <- grepl("[/\\\\]", arg) || grepl("\\.[a-zA-Z0-9]+$", arg)
  if (looks_like_file)
    return(TRUE)
  FALSE
}


## HAS_TESTS
#' Guess Whether Arguments are File Path
#'
#' If one or more arguments start with dots,
#' then assume that these arguments are file
#' paths. Otherwise use function
#' `is_actual_or_potential_file_path()`.
#'
#' @param args Named list of arguments from
#' call to `cmd_assign()`.
#'
#' @return Logical vector
#'
#' @noRd
is_file_arg <- function(args) {
  nms <- names(args)
  is_dot_arg <- grepl("^\\.", nms)
  if (any(is_dot_arg))
    ans <- is_dot_arg
  else
    ans <- vapply(args,
                  FUN = is_actual_or_potential_file_path,
                  FUN.VALUE = TRUE,
                  USE.NAMES = FALSE)
  ans
}


## HAS_TESTS
#' Check that 'nm' is a Valid Name for an Object in R
#'
#' @param nm A string
#'
#' @returns TRUE or FALSE
#'
#' @noRd
is_varname_valid <- function(nm) {
  if (grepl("?", nm, fixed = TRUE)) ## can be interpreted below as call to help
    return(FALSE) 
  text <- paste(nm, "<- 0")
  val <- tryCatch(eval(parse(text = text)),
                  error = function(e) e)
  !inherits(val, "error")
}


## HAS_TESTS
#' Make Shell Commands for a Shell Script
#'
#' Loop through files, making
#' commands for ones that contain calls to
#' `cmd_assign()`.
#'
#' Assume that path constructed from 'dir_shell'
#' and 'path_files' exists and is valid
#'
#' @param path_files Path from 'dir_shell' to
#' directory where R code files exists
#' @param dir_make Location of Makefile
#' @param quiet Whether to suppress
#' progress messages. 
#'
#' @returns A list of strings
#'
#' @noRd
make_commands <- function(path_files,
                          dir_shell,
                          quiet) {
  path_files_comb <- path_join(dir_shell, path_files)
  file <- list.files(path_files_comb, full.names = TRUE)
  file <- path_rel(file, start = dir_shell)
  ans <- .mapply(extract_shell_if_possible,
                 dots = list(file = file),
                 MoreArgs = list(dir_shell = dir_shell,
                                 quiet = quiet))
  ans <- Filter(Negate(is.null), ans)
  ans <- unlist(ans)
  ans
}


## HAS_TESTS
#' Make Rules for a Makefile
#'
#' Loop through files, making
#' rules for ones that contain calls to
#' `cmd_assign()`.
#'
#' Assume that path constructed from 'dir_make'
#' and 'path_files' exists and is valid
#'
#' @param path_files Path from 'dir_make' to
#' directory where R code files exists
#' @param dir_make Location of Makefile
#'
#' @returns A list of strings
#' @param quiet Whether to suppress
#' progress messages. 
#'
#' @noRd
make_rules <- function(path_files,
                       dir_make,
                       quiet) {
  path_files_comb <- path_join(dir_make, path_files)
  file <- list.files(path_files_comb, full.names = TRUE)
  file <- path_rel(file, start = dir_make)
  ans <- .mapply(extract_make_if_possible,
                 dots = list(file = file),
                 MoreArgs = list(dir_make = dir_make,
                                 quiet = quiet))
  ans <- Filter(Negate(is.null), ans)
  ans <- unlist(ans)
  ans
}

## 'extract_shell' ----------------------------------------------------------------

test_that("'extract_shell' works with valid inputs - dir supplied", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  path_file <- "script.R"
  writeLines("cmd_assign(.data = 'data/mydata.csv', use_log = FALSE, .out = 'out/cleaned.rds')",
             con = path_join(dir_tmp, path_file))
  capture.output(ans_obtained <- extract_shell(path_file, dir_shell = dir_tmp))
  path_file_comb <- path_join(dir_tmp, path_file)
  ans_expected <- paste0("Rscript ", path_file_comb, " \\\n",
                         "  data/mydata.csv \\\n",
                         "  out/cleaned.rds \\\n",
                         "  --use_log=FALSE\n")
  expect_identical(ans_obtained, ans_expected)
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'extract_shell' works with valid inputs - dir not supplied", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  path_file <- path_join(path_rel(dir_tmp, dir_curr), "script.R")
  writeLines("cmd_assign(.data = 'data/mydata.csv', use_log = FALSE, .out = 'out/cleaned.rds')",
             con = path_join(dir_tmp, "script.R"))
  capture.output(ans_obtained <- extract_shell(path_file))
  path_file_comb <- path_join(".", path_file)
  ans_expected <- paste0("Rscript ", path_file_comb, " \\\n",
                         "  data/mydata.csv \\\n",
                         "  out/cleaned.rds \\\n",
                         "  --use_log=FALSE\n")
  expect_identical(ans_obtained, ans_expected)
  unlink(dir_tmp, recursive = TRUE)
})

## 'path_join' ----------------------------------------------------------------

test_that("'path_join' joins with forward slashes", {
  expect_identical(path_join("a", "b", "c"), "a/b/c")
  expect_identical(path_join(".", "src/script.R"), "src/script.R")
  expect_identical(path_join("."), ".")
  expect_identical(path_join("src", ".", "script.R"), "src/script.R")
})


## 'is_absolute_path' ---------------------------------------------------------

test_that("'is_absolute_path' recognises absolute paths", {
  expect_true(is_absolute_path("/tmp"))
  expect_true(is_absolute_path("C:/"))
  expect_true(is_absolute_path("C:\\Windows"))
  expect_true(is_absolute_path("\\\\server\\share"))
  expect_false(is_absolute_path("src/script.R"))
  expect_false(is_absolute_path("./script.R"))
  expect_false(is_absolute_path("~/script.R"))
})


## 'path_rel' -----------------------------------------------------------------

test_that("'path_rel' makes paths relative to start", {
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  dir.create(file.path(dir_tmp, "src"))
  writeLines("1", con = file.path(dir_tmp, "src/script.R"))
  expect_identical(path_rel(file.path(dir_tmp, "src/script.R"), start = dir_tmp),
                   "src/script.R")
  expect_identical(path_rel(dir_tmp, start = dir_tmp), ".")
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'path_rel' works when tempfile is under getwd() on Windows", {
  skip_if_not(.Platform$OS.type == "windows")
  ## tempfile()/getwd() can disagree on drive-letter case after
  ## normalizePath() (e.g. d: vs D:), which broke extract_make() on WinBuilder.
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  on.exit(unlink(dir_tmp, recursive = TRUE), add = TRUE)
  writeLines("1", con = file.path(dir_tmp, "script.R"))
  rel <- path_rel(file.path(dir_tmp, "script.R"), start = getwd())
  expect_false(is_absolute_path(rel))
  expect_match(rel, "script\\.R$")
})


## 'align_cmd_to_dots' --------------------------------------------------------

test_that("'align_cmd_to_dots' works on typical inputs supplied by makefile", {
  args_cmd <- list("file1", "file2", n_iter = 100, variant = "low")
  args_dots <- list(f1 = "f1", f2 = "f2", variant = "med", n_iter = 10)
  ans_obtained <- align_cmd_to_dots(args_cmd = args_cmd,
                                    args_dots = args_dots)
  ans_expected <- list(f1 = "file1", f2 = "file2", variant = "low", n_iter = 100)
  expect_identical(ans_obtained, ans_expected)
})

test_that("'align_cmd_to_dots' works when named argument comes before unnamed", {
  args_cmd <- list("file1", variant = "low", "file2", n_iter = 100)
  args_dots <- list(f1 = "f1", f2 = "f2", variant = "med", n_iter = 10)
  ans_obtained <- align_cmd_to_dots(args_cmd = args_cmd,
                                    args_dots = args_dots)
  ans_expected <- list(f1 = "file1", f2 = "file2", variant = "low", n_iter = 100)
  expect_identical(ans_obtained, ans_expected)
})

test_that("'align_cmd_to_dots' works when single unnamed argument", {
  args_cmd <- list("file1")
  args_dots <- list(f1 = "f1")
  ans_obtained <- align_cmd_to_dots(args_cmd = args_cmd,
                                    args_dots = args_dots)
  ans_expected <- list(f1 = "file1")
  expect_identical(ans_obtained, ans_expected)
})

test_that("'align_cmd_to_dots' works 'args_cmd' and 'args_dots' both length 0", {
  args_cmd <- list()
  args_dots <- list()
  ans_obtained <- align_cmd_to_dots(args_cmd = args_cmd,
                                    args_dots = args_dots)
  ans_expected <- list()
  expect_identical(ans_obtained, ans_expected)
})


## 'assign_args' --------------------------------------------------------------

test_that("'assign_args' creates correct objects in the parent frame, and returns as list", {
  args <- list(xx = 1, yy = "hello", zz = TRUE)
  envir <- new.env()
  ans_obtained <- assign_args(args = args, envir = envir, quiet = TRUE)
  expect_identical(envir$xx, 1)
  expect_identical(envir$yy, "hello")
  expect_identical(envir$zz, TRUE)
  expect_identical(ans_obtained, args)
})

test_that("'assign_args' creates expected message", {
  args <- list(xx = 1, yy = "hello", zz = TRUE)
  envir <- new.env()
  suppressMessages(
    expect_message(
      assign_args(args = args, envir = envir, quiet = FALSE),
      "Assigned object"
    )
  )
})

test_that("'assign_args' notes empty string in message", {
  args <- list(v = "")
  envir <- new.env()
  suppressMessages(
    expect_message(
      assign_args(args = args, envir = envir, quiet = FALSE),
      "an empty string"
    )
  )
})

test_that("'assign_args' works with empty args", {
  args <- list()
  envir <- new.env()
  ans_obtained <- assign_args(args = args, envir = envir, quiet = TRUE)
  expect_identical(length(envir), 0L)
  expect_identical(ans_obtained, args)
})
    

## 'extract_shell_if_possible' ------------------------------------------------

test_that("'extract_shell_if_possible' works with R file with cmd_assign", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  file <- "script.R"
  writeLines("cmd_assign(.data = 'data/mydata.csv', use_log = FALSE, .out = 'out/cleaned.rds')",
             con = file.path(dir_tmp, file))
  ans_obtained <- extract_shell_if_possible(file = file,
                                            dir_shell = dir_tmp,
                                            quiet = TRUE)
  ans_expected <- paste0("Rscript script.R \\\n",
                         "  data/mydata.csv \\\n",
                         "  out/cleaned.rds \\\n",
                         "  --use_log=FALSE\n")
  expect_identical(ans_obtained, ans_expected)
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'extract_shell_if_possible' throws expected message", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  file <- "script.R"
  writeLines("cmd_assign(.data = 'data/mydata.csv', use_log = FALSE, .out = 'out/cleaned.rds')",
             con = file.path(dir_tmp, file))
  expect_message(
    extract_shell_if_possible(file = file,
                              dir_shell = dir_tmp,
                              quiet = FALSE),
    "Extracted call to `cmd_assign\\(\\)")
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'extract_shell_if_possible' returns NULL with R file with no cmd_assign", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  file <- "script.R"
  writeLines("x <- 1",
             con = file.path(dir_tmp, "script.R"))
  ans_obtained <- extract_shell_if_possible(file = file,
                                            dir_shell = dir_tmp,
                                            quiet = TRUE)
  ans_expected <- NULL
  expect_identical(ans_obtained, ans_expected)
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'extract_shell_if_possible' returns NULL with non-R file", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  file <- "data.csv"
  write.csv(data.frame(a = 1, b = 2), file = file.path(dir_tmp, "data.csv"))
  ans_obtained <- extract_shell_if_possible(file = file,
                                            dir_shell = dir_tmp,
                                            quiet = TRUE)
  ans_expected <- NULL
  expect_identical(ans_obtained, ans_expected)
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'extract_shell_if_possible' throws error when cannot evaluate", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  file <- "script.r"
  writeLines("cmd_assign(.data = 'data/mydata.csv', FALSE, .out = 'out/cleaned.rds')",
             con = file.path(dir_tmp, file))
  expect_error(extract_shell_if_possible(file = file,
                                         dir_shell = dir_tmp,
                                         quiet = TRUE),
               "Problem extracting call to")
  unlink(dir_tmp, recursive = TRUE)
})


## 'extract_make_if_possible' -------------------------------------------------

test_that("'extract_make_if_possible' works with R file with cmd_assign", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  file <- "script.R"
  writeLines("cmd_assign(.data = 'data/mydata.csv', use_log = FALSE, .out = 'out/cleaned.rds')",
             con = file.path(dir_tmp, file))
  ans_obtained <- extract_make_if_possible(file = file,
                                           dir_make = dir_tmp,
                                           quiet = TRUE)
  ans_expected <- paste0("out/cleaned.rds: ", file, " \\\n",
                         "  data/mydata.csv\n",
                         "\t", "Rscript $^ $@ --use_log=FALSE\n")
  expect_identical(ans_obtained, ans_expected)
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'extract_make_if_possible' throws expected message", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  file <- "script.R"
  writeLines("cmd_assign(.data = 'data/mydata.csv', use_log = FALSE, .out = 'out/cleaned.rds')",
             con = file.path(dir_tmp, file))
  expect_message(
    extract_make_if_possible(file = file,
                             dir_make = dir_tmp,
                             quiet = FALSE),
    "Extracted call to")
  unlink(dir_tmp, recursive = TRUE)
})


test_that("'extract_make_if_possible' returns NULL with R file with no cmd_assign", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  file <- "script.R"
  writeLines("x <- 1",
             con = file.path(dir_tmp, "script.R"))
  ans_obtained <- extract_make_if_possible(file = file,
                                           dir_make = dir_tmp,
                                           quiet = TRUE)
  ans_expected <- NULL
  expect_identical(ans_obtained, ans_expected)
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'extract_make_if_possible' returns NULL with non-R file", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  file <- "data.csv"
  write.csv(data.frame(a = 1, b = 2), file = file.path(dir_tmp, "data.csv"))
  ans_obtained <- extract_make_if_possible(file = file,
                                           dir_make = dir_tmp,
                                           quiet = TRUE)
  ans_expected <- NULL
  expect_identical(ans_obtained, ans_expected)
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'extract_make_if_possible' throws error when cannot evaluate", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  file <- "script.r"
  writeLines("cmd_assign(.data = 'data/mydata.csv', FALSE, .out = 'out/cleaned.rds')",
             con = file.path(dir_tmp, file))
  expect_error(extract_make_if_possible(file = file,
                                        dir_make = dir_tmp,
                                        quiet = TRUE),
               "Problem extracting call to")
  unlink(dir_tmp, recursive = TRUE)
})


## 'coerce_arg_cmd' -----------------------------------------------------------

test_that("'coerce_arg_cmd' works with character", {
  ans_obtained <- coerce_arg_cmd(arg_cmd = "X",
                                 arg_dots = "Y",
                                 nm_cmd = "",
                                 nm_dots = "val")
  ans_expected <- "X"
  expect_identical(ans_obtained, ans_expected)
})

test_that("'coerce_arg_cmd' allows empty string for character", {
  ans_obtained <- coerce_arg_cmd(arg_cmd = "",
                                 arg_dots = "a",
                                 nm_cmd = "v",
                                 nm_dots = "v")
  expect_identical(ans_obtained, "")
})

test_that("'coerce_arg_cmd' rejects empty string for non-character", {
  expect_error(coerce_arg_cmd(arg_cmd = "",
                             arg_dots = 1L,
                             nm_cmd = "v",
                             nm_dots = "v"),
               "Empty value passed at command line for argument `v`.")
  expect_error(coerce_arg_cmd(arg_cmd = "",
                             arg_dots = TRUE,
                             nm_cmd = "v",
                             nm_dots = "v"),
               "Empty value passed at command line for argument `v`.")
  expect_error(coerce_arg_cmd(arg_cmd = "",
                             arg_dots = as.Date("2000-01-01"),
                             nm_cmd = "v",
                             nm_dots = "v"),
               "Empty value passed at command line for argument `v`.")
})

test_that("'coerce_arg_cmd' works with integer", {
  ans_obtained <- coerce_arg_cmd(arg_cmd = "111",
                                 arg_dots = 1L,
                                 nm_cmd = "",
                                 nm_dots = "val")
  ans_expected <- 111L
  expect_identical(ans_obtained, ans_expected)
})

test_that("'coerce_arg_cmd' works with numeric", {
  ans_obtained <- coerce_arg_cmd(arg_cmd = "111",
                                 arg_dots = 1.0,
                                 nm_cmd = "",
                                 nm_dots = "val")
  ans_expected <- 111.0
  expect_identical(ans_obtained, ans_expected)
})

test_that("'coerce_arg_cmd' works with logical", {
  ans_obtained <- coerce_arg_cmd(arg_cmd = "F",
                                 arg_dots = NA,
                                 nm_cmd = "",
                                 nm_dots = "val")
  ans_expected <- FALSE
  expect_identical(ans_obtained, ans_expected)
})

test_that("'coerce_arg_cmd' works with Date", {
  ans_obtained <- coerce_arg_cmd(arg_cmd = "2001-02-01",
                                 arg_dots = as.Date("2000-01-01"),
                                 nm_cmd = "",
                                 nm_dots = "val")
  ans_expected <- as.Date("2001-02-01")
  expect_identical(ans_obtained, ans_expected)
})

test_that("'coerce_arg_cmd' works with POSIXct", {
  ans_obtained <- coerce_arg_cmd(arg_cmd = "2001-02-01 12:13:14",
                                 arg_dots = as.POSIXct("2000-01-01", tz = "EST"),
                                 nm_cmd = "",
                                 nm_dots = "val")
  ans_expected <- as.POSIXct("2001-02-01 12:13:14", tz = "EST")
  expect_identical(ans_obtained, ans_expected)
})

test_that("'coerce_arg_cmd' works with POSIXlt", {
  ans_obtained <- coerce_arg_cmd(arg_cmd = "2001-02-01 12:13:14",
                                 arg_dots = as.POSIXlt("2000-01-01", tz = "EST"),
                                 nm_cmd = "",
                                 nm_dots = "val")
  ans_expected <- as.POSIXlt("2001-02-01 12:13:14", tz = "EST")
  expect_identical(ans_obtained, ans_expected)
})

test_that("'coerce_arg_cmd' works with NULL", {
  ans_obtained <- coerce_arg_cmd(arg_cmd = "NULL",
                                 arg_dots = NULL,
                                 nm_cmd = "",
                                 nm_dots = "val")
  ans_expected <- NULL
  expect_identical(ans_obtained, ans_expected)
})

test_that("'coerce_arg_cmd' throws expected error with unexpected class", {
  expect_error(coerce_arg_cmd(arg_cmd = "NULL",
                                 arg_dots = raw(),
                                 nm_cmd = "",
                              nm_dots = "val"),
               "Internal error: `arg_dots` has class")
})

test_that("'coerce_arg_cmd' throws expected error when can't coerce", {
  expect_error(coerce_arg_cmd(arg_cmd = "a",
                              arg_dots = 1L,
                              nm_cmd = "",
                              nm_dots = "val"),
               "Can't coerce value passed at command line to class specified by `cmd_assign\\(\\)")
})


## 'coerce_to_dots_class' -----------------------------------------------------

test_that("'coerce_to_dots_class' works with valid inputs", {
    args_cmd <- list(a = "TRUE", b = "1", c = "1", d = "1")
    args_dots <- list(a = NA, b = 1L, c = 1, d = "1")
    ans_obtained <- coerce_to_dots_class(args_cmd = args_cmd,
                                         args_dots = args_dots)
    ans_expected <- list(a = TRUE, b = 1L, c = 1, d = "1")
    expect_identical(ans_obtained, ans_expected)
})

test_that("'coerce_to_dots_class' throws correct error when cannot coerce", {
    args_cmd <- list(a = "TRUE", b = "1", c = "a", d = "1")
    args_dots <- list(a = NA, b = 1L, c = 1, d = "1")
    expect_error(coerce_to_dots_class(args_cmd = args_cmd,
                                      args_dots = args_dots),
                 "Can't coerce value passed at command line")
})


## 'extract_args' -------------------------------------------------------------

test_that("'extract_args' works with valid inputs", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  setwd(dir_tmp)
  writeLines(c("x <- 1",
               "cmd_assign(a = 1L, b = as.Date('2020-01-01'), c = FALSE)",
               "y <- 2"),
             con = "script.R")
  ans_obtained <- extract_args("script.R")
  ans_expected <- list(a = 1L, b = as.Date("2020-01-01"), c = FALSE)
  expect_identical(ans_obtained, ans_expected)
  setwd(dir_curr)
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'extract_args' gives warning when no call to cmd_assign() found", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  setwd(dir_tmp)
  writeLines(c("x <- 1",
               "y <- 2"),
             con = "script.R")
  expect_message(ans <- extract_args("script.R"),
                 "No call to `cmd_assign\\(\\)` found.")
  expect_identical(ans, NULL)
  setwd(dir_curr)
  unlink(dir_tmp, recursive = TRUE)
})


## 'format_args_make' ---------------------------------------------------------

test_that("'format_args_make works with file and non-file args", {
  file <- "src/bla.R"
  args <- list(a = 1, b = "x.R", c = "out/bla.rds")
  ans_obtained <- format_args_make(file = file, args = args)
  ans_expected <- paste(c("out/bla.rds: src/bla.R \\",
                          "  x.R",
                          "\tRscript $^ $@ --a=1\n"),
                        collapse = "\n")
  expect_identical(ans_obtained, ans_expected)
})

test_that("'format_args_make works with one file and one non-file args", {
  file <- "src/bla.R"
  args <- list(a = 1, c = "out/bla.rds")
  ans_obtained <- format_args_make(file = file, args = args)
  ans_expected <- paste(c("out/bla.rds: src/bla.R",
                          "\tRscript $^ $@ --a=1\n"),
                        collapse = "\n")
  expect_identical(ans_obtained, ans_expected)
})

test_that("'format_args_make works with file and no non-file args", {
  file <- "src/bla.R"
  args <- list(b = "x.R", c = "out/bla.rds")
  ans_obtained <- format_args_make(file = file, args = args)
  ans_expected <- paste(c("out/bla.rds: src/bla.R \\",
                          "  x.R",
                          "\tRscript $^ $@\n"),
                        collapse = "\n")
  expect_identical(ans_obtained, ans_expected)
})

test_that("'format_args_make works with one file and no non-file args", {
  file <- "src/bla.R"
  args <- list(c = "out/bla.rds")
  ans_obtained <- format_args_make(file = file, args = args)
  ans_expected <- paste(c("out/bla.rds: src/bla.R",
                          "\tRscript $^ $@\n"),
                        collapse = "\n")
  expect_identical(ans_obtained, ans_expected)
})

test_that("'format_args_make throws error when no file arguments", {
  file <- "src/bla.R"
  args <- list(c = 1L)
  expect_error(format_args_make(file = file, args = args),
               "Can't find any file arguments.")
})


## 'format_args_shell' --------------------------------------------------------

test_that("'format_args_shell works with file and non-file args", {
  file <- "src/myfile.R"
  args <- list(a = 1, b = "x.R")
  ans_obtained <- format_args_shell(file = file, args = args)
  ans_expected <- paste(c("Rscript src/myfile.R \\",
                          "  x.R \\",
                          "  --a=1\n"),
                        collapse = "\n")
  expect_identical(ans_obtained, ans_expected)
})

test_that("'format_args_shell works with file arg only", {
  file <- "src/myfile.R"
  args <- list(b = "x.R")
  ans_obtained <- format_args_shell(file = file, args = args)
  ans_expected <- paste(c("Rscript src/myfile.R \\",
                          "  x.R\n"),
                        collapse = "\n")
  expect_identical(ans_obtained, ans_expected)
})

test_that("'format_args_shell works with non-file arg only", {
  file <- "src/myfile.R"
  args <- list(a = 1)
  ans_obtained <- format_args_shell(file = file, args = args)
  ans_expected <- paste(c("Rscript src/myfile.R \\",
                          "  --a=1\n"),
                        collapse = "\n")
  expect_identical(ans_obtained, ans_expected)
})

test_that("'format_args_shell works no args", {
  file <- "src/myfile.R"
  args <- list()
  ans_obtained <- format_args_shell(file = file, args = args)
  ans_expected <- "Rscript src/myfile.R\n"
  expect_identical(ans_obtained, ans_expected)
})


## 'get_args_cmd' -------------------------------------------------------------

test_that("'get_args_cmd' works with valid inputs", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  setwd(dir_tmp)
  writeLines(c("args <- command:::get_args_cmd()",
               "saveRDS(args, file = 'args.rds')"),
             con = "script.R")
  cmd <- sprintf('%s/bin/Rscript script.R unnamed1 -n=1 unnamed2 --named1=hello --named2="kia ora"', R.home())
  system(cmd)
  ans_obtained <- readRDS("args.rds")
  ans_expected <- list("unnamed1", n = "1", "unnamed2", named1 = "hello", named2 = "kia ora")
  expect_identical(ans_obtained, ans_expected)
  setwd(dir_curr)
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'get_args_cmd' works when no arguments passed", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  setwd(dir_tmp)
  writeLines(c("args <- command:::get_args_cmd()",
               "saveRDS(args, file = 'args.rds')"),
             con = "script.R")
  cmd <- sprintf("%s/bin/Rscript script.R", R.home())
  system(cmd)
  args <- readRDS("args.rds")
  expect_identical(args, list())
  setwd(dir_curr)
  unlink(dir_tmp, recursive = TRUE)
})

## Empty value after '=' (e.g. Make expands --v=$(V) when V is undefined)
test_that("'get_args_cmd' treats --v= as named argument with empty string", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  setwd(dir_tmp)
  writeLines(c("args <- command:::get_args_cmd()",
               "saveRDS(args, file = 'args.rds')"),
             con = "script.R")
  cmd <- sprintf("%s/bin/Rscript script.R --v=", R.home())
  system(cmd)
  ans_obtained <- readRDS("args.rds")
  ans_expected <- list(v = "")
  expect_identical(ans_obtained, ans_expected)
  setwd(dir_curr)
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'get_args_cmd' works with littler", {
  skip_if_no_littler_available()
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  setwd(dir_tmp)
  writeLines(c("args <- command:::get_args_cmd()",
               "saveRDS(args, file = 'args.rds')"),
             con = "script.R")
  cmd <- 'lr script.R unnamed1 -n=1 unnamed2 --named1=hello --named2="kia ora"'
  system(cmd)
  ans_obtained <- readRDS("args.rds")
  ans_expected <- list("unnamed1", n = "1", "unnamed2", named1 = "hello", named2 = "kia ora")
  expect_identical(ans_obtained, ans_expected)
  setwd(dir_curr)
  unlink(dir_tmp, recursive = TRUE)
})




## 'is_actual_or_potential_file_path' -----------------------------------------

test_that("'is_actual_or_potential_file_path' returns FALSE if is non-character or NA", {
  expect_false(is_actual_or_potential_file_path(1))
  expect_false(is_actual_or_potential_file_path(FALSE))
  expect_false(is_actual_or_potential_file_path(NA_character_))
})

test_that("'is_actual_or_potential_file_path' returns TRUE if file exists", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  setwd(dir_tmp)
  writeLines("1",
             con = "mydata.csv")
  ans <- is_actual_or_potential_file_path("mydata.csv")
  expect_true(ans)
  setwd(dir_curr)
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'is_actual_or_potential_file_path' returns TRUE if file is directory", {
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  expect_true(is_actual_or_potential_file_path(dir_tmp))
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'is_actual_or_potential_file_path' returns TRUE if is potential file", {
  expect_true(is_actual_or_potential_file_path("mydir/myfile.r"))
  expect_false(is_actual_or_potential_file_path(".777!"))
  expect_false(is_actual_or_potential_file_path("*"))
})


## 'is_file_arg' --------------------------------------------------------------

test_that("'is_file_arg' works with dot arguments", {
  args <- list(a = 1, .b = "x.r", c = FALSE, .d = "x.c")
  ans_obtained <- is_file_arg(args)
  ans_expected <- c(FALSE, TRUE, FALSE, TRUE)
  expect_identical(ans_obtained, ans_expected)
})

test_that("'is_file_arg' works with non-dot arguments", {
  args <- list(a = 1, b = "x.r", c = FALSE, d = "x.c")
  ans_obtained <- is_file_arg(args)
  ans_expected <- c(FALSE, TRUE, FALSE, TRUE)
  expect_identical(ans_obtained, ans_expected)
})


## 'is_varname_valid' ---------------------------------------------------------

test_that("'is_varname_valid' returns TRUE with valid names", {
  expect_true(is_varname_valid("x"))
  expect_true(is_varname_valid("....x"))
  expect_true(is_varname_valid("X_X_..3"))
})

test_that("'is_varname_valid' returns FALSE with invalid names", {
  expect_false(is_varname_valid("_x"))
  expect_false(is_varname_valid(" "))
  expect_false(is_varname_valid("NA"))
  expect_false(is_varname_valid("if"))
  expect_false(is_varname_valid("x x"))
  expect_false(is_varname_valid("?X_X_..3"))
})


## 'make_commands' ------------------------------------------------------------

test_that("'make_commands' works with valid input - path_files in same directory", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  f1 <- file.path(dir_tmp, "script.R")
  writeLines("cmd_assign(.data = 'data/mydata.csv', use_log = FALSE, .out = 'out/cleaned.rds')",
             con = f1)
  f2 <- file.path(dir_tmp, "data.R")
  writeLines("1",
             con = f2)
  ans_obtained <- make_commands(path_files = ".",
                                dir_shell = dir_tmp,
                                quiet = TRUE)
  ans_expected <- paste0("Rscript script.R \\\n",
                         "  data/mydata.csv \\\n",
                         "  out/cleaned.rds \\\n",
                         "  --use_log=FALSE\n")
  expect_identical(ans_obtained, ans_expected)
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'make_commands' works with valid input - path_files in lower directory", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  dir.create(file.path(dir_tmp, "src"))
  f1 <- file.path(dir_tmp, "src/script.R")
  writeLines("cmd_assign(.data = 'data/mydata.csv', use_log = FALSE, .out = 'out/cleaned.rds')",
             con = f1)
  f2 <- file.path(dir_tmp, "src/data.R")
  writeLines("1",
             con = f2)
  ans_obtained <- make_commands(path_files = "src",
                                dir_shell = dir_tmp,
                                quiet = TRUE)
  ans_expected <- paste0("Rscript src/script.R \\\n",
                         "  data/mydata.csv \\\n",
                         "  out/cleaned.rds \\\n",
                         "  --use_log=FALSE\n")
  expect_identical(ans_obtained, ans_expected)
  unlink(dir_tmp, recursive = TRUE)
})


## 'make_rules' ---------------------------------------------------------------

test_that("'make_rules' works with valid input - path_files in same directory", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  f1 <- file.path(dir_tmp, "script.R")
  writeLines("cmd_assign(.data = 'data/mydata.csv', use_log = FALSE, .out = 'out/cleaned.rds')",
             con = f1)
  f2 <- file.path(dir_tmp, "data.R")
  writeLines("1",
             con = f2)
  ans_obtained <- make_rules(path_files = ".",
                             dir_make = dir_tmp,
                             quiet = TRUE)
  ans_expected <- paste0("out/cleaned.rds: ", "script.R", " \\\n",
                         "  data/mydata.csv\n",
                         "\t", "Rscript $^ $@ --use_log=FALSE\n")
  expect_identical(ans_obtained, ans_expected)
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'make_rules' works with valid input - path_files in lower directory", {
  dir_curr <- getwd()
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  dir.create(file.path(dir_tmp, "src"))
  f1 <- file.path(dir_tmp, "src/script.R")
  writeLines("cmd_assign(.data = 'data/mydata.csv', use_log = FALSE, .out = 'out/cleaned.rds')",
             con = f1)
  f2 <- file.path(dir_tmp, "src/data.R")
  writeLines("1",
             con = f2)
  ans_obtained <- make_rules(path_files = "src",
                             dir_make = dir_tmp,
                             quiet = TRUE)
  ans_expected <- paste0("out/cleaned.rds: ", "src/script.R", " \\\n",
                         "  data/mydata.csv\n",
                         "\t", "Rscript $^ $@ --use_log=FALSE\n")
  expect_identical(ans_obtained, ans_expected)
  unlink(dir_tmp, recursive = TRUE)
})

## 'extract_make' -----------------------------------------------------------------

test_that("'extract_make' works with no dir_make", {
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  path_file <- path_rel(path = file.path(dir_tmp, "script.R"),
                        start = getwd())
  writeLines("cmd_assign(.data = 'data/mydata.csv', use_log = FALSE, .out = 'out/cleaned.rds')",
             con = path_file)
  capture.output(ans_obtained <- extract_make(path_file = path_file))
  path_file_comb <- path_join(".", path_file)
  ans_expected <- paste0("out/cleaned.rds: ", path_file_comb, " \\\n",
                         "  data/mydata.csv\n",
                         "\t", "Rscript $^ $@ --use_log=FALSE\n")
  expect_identical(ans_obtained, ans_expected)
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'extract_make' works with dir_make", {
  dir_tmp <- tempfile(tmpdir = getwd())
  if (file.exists(dir_tmp))
    unlink(dir_tmp, recursive = TRUE)
  dir.create(dir_tmp)
  path_file <- "script.R"
  writeLines("cmd_assign(.data = 'data/mydata.csv', use_log = FALSE, .out = 'out/cleaned.rds')",
             con = path_join(dir_tmp, path_file))
  capture.output(ans_obtained <- extract_make(path_file = path_file,
                                          dir_make = dir_tmp))
  path_file_comb <- path_join(dir_tmp, path_file)
  ans_expected <- paste0("out/cleaned.rds: ", path_file_comb, " \\\n",
                         "  data/mydata.csv\n",
                         "\t", "Rscript $^ $@ --use_log=FALSE\n")
  expect_identical(ans_obtained, ans_expected)
  unlink(dir_tmp, recursive = TRUE)
})

littler_available <- function() {
  os <- Sys.info()[["sysname"]]
  if (os == "Windows")
    return(FALSE)
  cmd <- if (os == "Darwin") "lr" else "r"
  path <- Sys.which(cmd)
  if (!nzchar(path))
    return(FALSE)
  ## Confirm the binary identifies as littler (not some other 'r'/'lr').
  out <- suppressWarnings(system2(cmd, "--version", stdout = TRUE, stderr = TRUE))
  if (!length(out))
    out <- suppressWarnings(system2(cmd, "-h", stdout = TRUE, stderr = TRUE))
  if (!any(grepl("\\blittler\\b", out, ignore.case = TRUE)))
    return(FALSE)
  ## Also confirm it can actually execute R code. A stale binary linked
  ## against an older R can still answer --version but segfault on use.
  script <- tempfile(fileext = ".R")
  on.exit(unlink(script), add = TRUE)
  writeLines("invisible(NULL)", script)
  status <- suppressWarnings(
    system2(cmd, script, stdout = FALSE, stderr = FALSE)
  )
  identical(as.integer(status), 0L)
}

skip_if_no_littler_available <- function() {
  if (!littler_available())
    testthat::skip("littler not callable via system()")
}

## Probe scripts for subprocess tests of script_dir(). Under R CMD check
## the package is installed; pass the parent .libPaths() so the child
## finds that install without needing devtools::load_all().
write_script_dir_probe <- function(script, out) {
  libs <- paste(encodeString(.libPaths(), quote = '"'), collapse = ", ")
  writeLines(c(
    sprintf(".libPaths(c(%s))", libs),
    "library(command)",
    sprintf('saveRDS(command:::script_dir(), "%s")',
            gsub("\\\\", "/", out))
  ), script)
}

## HAS_TESTS
#' Directory Containing the Current Script, If Known
#'
#' Tries, in order:
#' 1. `Rscript`'s `--file=` argument in [commandArgs()];
#' 2. under [littler](https://CRAN.R-project.org/package=littler), a
#'    walk of the call stack for `srcref` information
#'    (littler keeps source references; `Rscript` does not).
#'
#' Returns `NULL` if the script directory cannot be determined
#' (caller typically falls back to [getwd()]).
#'
#' @returns A length-1 character string, or `NULL`
#'
#' @noRd
script_dir <- function() {
  args <- commandArgs(trailingOnly = FALSE)
  ## 1) Rscript --file=/path/to/script.R
  file_arg <- grep("^--file=", args, value = TRUE)
  if (length(file_arg)) {
    path <- sub("^--file=", "", file_arg[[1L]])
    ## Rscript may pass a relative path; dirname still works.
    dir <- dirname(path)
    if (!nzchar(dir) || identical(dir, "."))
      dir <- getwd()
    return(normalizePath(dir, winslash = "/", mustWork = FALSE))
  }
  ## 2) littler: no --file=, but top-level expressions carry srcrefs
  if (length(args) >= 1L && identical(args[[1L]], "littler")) {
    dir <- script_dir_from_srcref()
    if (!is.null(dir))
      return(dir)
  }
  NULL
}


## HAS_TESTS
#' Script Directory From Call-Stack Source References
#'
#' Used under littler, which parses scripts with source references.
#' Walks caller frames so this works when invoked from package code
#' (e.g. `use_renv()` → `script_dir()`), not only at top level.
#'
#' @returns Normalized directory path, or `NULL`
#'
#' @noRd
script_dir_from_srcref <- function() {
  n <- sys.nframe()
  for (i in seq_len(n)) {
    sr <- attr(sys.call(i), "srcref")
    if (is.null(sr)) {
      fun <- sys.function(i)
      if (!is.null(fun))
        sr <- attr(fun, "srcref")
    }
    if (is.null(sr))
      next
    d <- utils::getSrcDirectory(sr)
    if (length(d) == 1L && nzchar(d))
      return(normalizePath(d, winslash = "/", mustWork = FALSE))
  }
  NULL
}


## HAS_TESTS
#' Walk Up From a Directory Looking for a renv Project Root
#'
#' A directory is treated as a renv root if it contains
#' `renv/activate.R` or `renv.lock`.
#'
#' @param start Directory to start from
#' @param max_depth Maximum number of parents to visit
#'
#' @returns Normalized path to the root, or `NULL`
#'
#' @noRd
find_renv_root <- function(start, max_depth = 20L) {
  dir <- normalizePath(start, winslash = "/", mustWork = FALSE)
  if (!dir.exists(dir) && file.exists(dir))
    dir <- dirname(dir)
  for (i in seq_len(max_depth)) {
    if (!dir.exists(dir))
      return(NULL)
    if (file.exists(file.path(dir, "renv", "activate.R")) ||
        file.exists(file.path(dir, "renv.lock")))
      return(normalizePath(dir, winslash = "/", mustWork = TRUE))
    parent <- dirname(dir)
    if (identical(parent, dir))
      return(NULL)
    dir <- parent
  }
  NULL
}


## HAS_TESTS
#' Is renv Already Active for This Project?
#'
#' @param project Normalized project root
#'
#' @returns `TRUE` or `FALSE`
#'
#' @noRd
renv_active_for <- function(project) {
  env_proj <- Sys.getenv("RENV_PROJECT", unset = "")
  if (!nzchar(env_proj))
    return(FALSE)
  env_proj <- normalizePath(env_proj, winslash = "/", mustWork = FALSE)
  identical(env_proj, project)
}


#' Activate an renv Project for the Current Session
#'
#' Make sure `renv` is activated, even if a script is run from 
#' Rscript or littler.
#'
#' Package [renv](https://rstudio.github.io/renv/)
#' makes workflows reproducible by locking down the versions of 
#' R packages. Normal `renv` mechanisms can fail, however,
#' if a script is run from Rscript or littler.
#' Adding
#' ```
#' command::use_renv()
#' ```
#' to the top of R scripts fixes the problem.
#' 
#' For more details, see the article
#' [Using command with renv](https://bayesiandemography.github.io/command/articles/a5_renv.html).
#'
#' @param project Optional path to a project root. If `NULL`
#'   (the default), search upward from the script's directory
#'   when known, otherwise from `getwd()`. The script directory
#'   is taken from `Rscript`'s `--file=` argument when present,
#'   or from source references under littler.
#' @param quiet If `TRUE` (the default), suppress messages.
#'
#' @returns The project root path (invisibly) if renv was activated
#'   or was already active; otherwise `NULL`.
#'
#' @seealso
#' - [cmd_assign()] Process command line arguments
#' - [Using command with renv](https://bayesiandemography.github.io/command/articles/a5_renv.html)
#'
#' @examples
#' command::use_renv() ## if renv not used here, no effect
#' 
#' ## see article for full example
#' @export
use_renv <- function(project = NULL, quiet = TRUE) {
  check_flag(x = quiet, nm = "quiet")
  if (is.null(project)) {
    start <- script_dir()
    if (is.null(start))
      start <- getwd()
    root <- find_renv_root(start)
  } else {
    if (!identical(length(project), 1L) || !is.character(project) || is.na(project))
      cli::cli_abort(c("{.arg project} must be a single character string.",
                       i = "{.arg project} has class {.cls {class(project)}}."))
    if (!dir.exists(project))
      cli::cli_abort(c("Can't find project directory.",
                       i = "Directory: {.path {project}}"))
    root <- normalizePath(project, winslash = "/", mustWork = TRUE)
    has_activate <- file.exists(file.path(root, "renv", "activate.R"))
    has_lock <- file.exists(file.path(root, "renv.lock"))
    if (!has_activate && !has_lock) {
      if (!quiet)
        cli::cli_alert_warning("No renv project found at {.path {root}}.")
      return(invisible(NULL))
    }
  }

  if (is.null(root)) {
    if (!quiet)
      cli::cli_alert_info("No renv project found.")
    return(invisible(NULL))
  }

  if (renv_active_for(root))
    return(invisible(root))

  activate <- file.path(root, "renv", "activate.R")
  if (!file.exists(activate)) {
    ## Always warn: quiet only suppresses happy-path messages.
    cli::cli_warn(c(
      "Found {.file renv.lock} but no {.file renv/activate.R}.",
      i = "Project: {.path {root}}.",
      i = paste("Nothing was activated. If this project uses renv,",
                "restore or recreate {.file renv/activate.R}.")
    ))
    return(invisible(NULL))
  }

  source(activate, local = FALSE)
  if (!quiet)
    cli::cli_alert_success("Activated renv project at {.path {root}}.")
  invisible(root)
}

## 'script_dir' ---------------------------------------------------------------

test_that("'script_dir' returns NULL outside Rscript --file and littler", {
  args <- commandArgs(trailingOnly = FALSE)
  if (any(grepl("^--file=", args)))
    skip("Running with --file=")
  if (length(args) >= 1L && identical(args[[1L]], "littler"))
    skip("Running under littler")
  expect_null(script_dir())
})

test_that("'script_dir' finds script directory under Rscript from other cwd", {
  dir_curr <- getwd()
  dir_tmp <- tempfile()
  dir.create(dir_tmp)
  dir.create(file.path(dir_tmp, "src"))
  dir_other <- tempfile()
  dir.create(dir_other)
  script <- file.path(dir_tmp, "src", "probe.R")
  out <- file.path(dir_tmp, "result.rds")
  write_script_dir_probe(script, out)
  on.exit({
    setwd(dir_curr)
    unlink(dir_tmp, recursive = TRUE)
    unlink(dir_other, recursive = TRUE)
  })
  setwd(dir_other)
  status <- system2(file.path(R.home("bin"), "Rscript"), script,
                    stdout = FALSE, stderr = FALSE)
  expect_identical(as.integer(status), 0L)
  expect_identical(readRDS(out),
                   normalizePath(file.path(dir_tmp, "src"), winslash = "/"))
})

test_that("'script_dir' finds script directory under littler from other cwd", {
  skip_if_no_littler_available()
  dir_curr <- getwd()
  dir_tmp <- tempfile()
  dir.create(dir_tmp)
  dir.create(file.path(dir_tmp, "src"))
  dir_other <- tempfile()
  dir.create(dir_other)
  script <- file.path(dir_tmp, "src", "probe.R")
  out <- file.path(dir_tmp, "result.rds")
  write_script_dir_probe(script, out)
  on.exit({
    setwd(dir_curr)
    unlink(dir_tmp, recursive = TRUE)
    unlink(dir_other, recursive = TRUE)
  })
  setwd(dir_other)
  cmd <- if (Sys.info()[["sysname"]] == "Darwin") "lr" else "r"
  status <- system2(cmd, script, stdout = FALSE, stderr = FALSE)
  expect_identical(as.integer(status), 0L)
  expect_identical(readRDS(out),
                   normalizePath(file.path(dir_tmp, "src"), winslash = "/"))
})


## 'find_renv_root' -----------------------------------------------------------

test_that("'find_renv_root' finds root via renv/activate.R", {
  dir_tmp <- tempfile()
  dir.create(dir_tmp)
  dir.create(file.path(dir_tmp, "renv"))
  writeLines("# stub", file.path(dir_tmp, "renv", "activate.R"))
  dir.create(file.path(dir_tmp, "src"))
  ans <- find_renv_root(file.path(dir_tmp, "src"))
  expect_identical(ans, normalizePath(dir_tmp, winslash = "/"))
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'find_renv_root' finds root via renv.lock", {
  dir_tmp <- tempfile()
  dir.create(dir_tmp)
  writeLines("{}", file.path(dir_tmp, "renv.lock"))
  ans <- find_renv_root(dir_tmp)
  expect_identical(ans, normalizePath(dir_tmp, winslash = "/"))
  unlink(dir_tmp, recursive = TRUE)
})

test_that("'find_renv_root' returns NULL when no project", {
  dir_tmp <- tempfile()
  dir.create(dir_tmp)
  expect_null(find_renv_root(dir_tmp))
  unlink(dir_tmp, recursive = TRUE)
})


## 'renv_active_for' ----------------------------------------------------------

test_that("'renv_active_for' is FALSE when RENV_PROJECT unset", {
  old <- Sys.getenv("RENV_PROJECT", unset = NA_character_)
  Sys.unsetenv("RENV_PROJECT")
  on.exit({
    if (is.na(old)) Sys.unsetenv("RENV_PROJECT") else Sys.setenv(RENV_PROJECT = old)
  })
  expect_false(renv_active_for(getwd()))
})

test_that("'renv_active_for' is TRUE when RENV_PROJECT matches", {
  dir_tmp <- tempfile()
  dir.create(dir_tmp)
  root <- normalizePath(dir_tmp, winslash = "/")
  old <- Sys.getenv("RENV_PROJECT", unset = NA_character_)
  Sys.setenv(RENV_PROJECT = root)
  on.exit({
    if (is.na(old)) Sys.unsetenv("RENV_PROJECT") else Sys.setenv(RENV_PROJECT = old)
    unlink(dir_tmp, recursive = TRUE)
  })
  expect_true(renv_active_for(root))
})


## 'use_renv' -----------------------------------------------------------------

test_that("'use_renv' returns NULL when no project", {
  dir_curr <- getwd()
  dir_tmp <- tempfile()
  dir.create(dir_tmp)
  old <- Sys.getenv("RENV_PROJECT", unset = NA_character_)
  Sys.unsetenv("RENV_PROJECT")
  setwd(dir_tmp)
  on.exit({
    setwd(dir_curr)
    if (is.na(old)) Sys.unsetenv("RENV_PROJECT") else Sys.setenv(RENV_PROJECT = old)
    unlink(dir_tmp, recursive = TRUE)
  })
  expect_null(use_renv())
})

test_that("'use_renv' sources activate.R for explicit project", {
  dir_tmp <- tempfile()
  dir.create(dir_tmp)
  dir.create(file.path(dir_tmp, "renv"))
  marker <- file.path(dir_tmp, "activated.txt")
  writeLines(sprintf('cat("ok", file = "%s")',
                     gsub("\\\\", "/", marker)),
             file.path(dir_tmp, "renv", "activate.R"))
  old <- Sys.getenv("RENV_PROJECT", unset = NA_character_)
  Sys.unsetenv("RENV_PROJECT")
  on.exit({
    if (is.na(old)) Sys.unsetenv("RENV_PROJECT") else Sys.setenv(RENV_PROJECT = old)
    unlink(dir_tmp, recursive = TRUE)
  })
  ans <- use_renv(project = dir_tmp)
  expect_identical(ans, normalizePath(dir_tmp, winslash = "/"))
  expect_true(file.exists(marker))
})

test_that("'use_renv' is idempotent when RENV_PROJECT already set", {
  dir_tmp <- tempfile()
  dir.create(dir_tmp)
  dir.create(file.path(dir_tmp, "renv"))
  root <- normalizePath(dir_tmp, winslash = "/")
  writeLines('stop("should not source activate.R")',
             file.path(dir_tmp, "renv", "activate.R"))
  old <- Sys.getenv("RENV_PROJECT", unset = NA_character_)
  Sys.setenv(RENV_PROJECT = root)
  on.exit({
    if (is.na(old)) Sys.unsetenv("RENV_PROJECT") else Sys.setenv(RENV_PROJECT = old)
    unlink(dir_tmp, recursive = TRUE)
  })
  expect_identical(use_renv(project = dir_tmp), root)
})

test_that("'use_renv' with only renv.lock warns and returns NULL", {
  dir_tmp <- tempfile()
  dir.create(dir_tmp)
  writeLines("{}", file.path(dir_tmp, "renv.lock"))
  old <- Sys.getenv("RENV_PROJECT", unset = NA_character_)
  Sys.unsetenv("RENV_PROJECT")
  on.exit({
    if (is.na(old)) Sys.unsetenv("RENV_PROJECT") else Sys.setenv(RENV_PROJECT = old)
    unlink(dir_tmp, recursive = TRUE)
  })
  expect_warning(
    ans <- use_renv(project = dir_tmp),
    "renv.lock"
  )
  expect_null(ans)
})

test_that("'use_renv' errors when project path missing", {
  expect_error(use_renv(project = tempfile()),
               "Can't find project directory")
})

test_that("'use_renv' discovers project by walking up from getwd()", {
  dir_curr <- getwd()
  dir_tmp <- tempfile()
  dir.create(dir_tmp)
  dir.create(file.path(dir_tmp, "renv"))
  dir.create(file.path(dir_tmp, "src"))
  marker <- file.path(dir_tmp, "activated.txt")
  writeLines(sprintf('cat("ok", file = "%s")',
                     gsub("\\\\", "/", marker)),
             file.path(dir_tmp, "renv", "activate.R"))
  setwd(file.path(dir_tmp, "src"))
  old <- Sys.getenv("RENV_PROJECT", unset = NA_character_)
  Sys.unsetenv("RENV_PROJECT")
  on.exit({
    setwd(dir_curr)
    if (is.na(old)) Sys.unsetenv("RENV_PROJECT") else Sys.setenv(RENV_PROJECT = old)
    unlink(dir_tmp, recursive = TRUE)
  })
  ans <- use_renv()
  expect_identical(ans, normalizePath(dir_tmp, winslash = "/"))
  expect_true(file.exists(marker))
})

---
title: "Smoothed Passenger Miles"
format: html
---

We smoothing our data using a spline with 5 knots:

```{r}
#| label: fig_smoothed_5
#| echo: false
knitr::include_graphics("fig_smoothed_5.png")
```

And smooth it again using a spline with 10 knots

```{r}
#| label: fig_smoothed_10
#| echo: false
knitr::include_graphics("fig_smoothed_10.png")
```

---
title: "Swiss Fertility"
---

## Introduction

We examine the relationship between agriculture and fertility in nineteenth century Swizterland.

## Methods

We fit a robust linear model to provincial-level data.

## Results

Here are the raw data and the fitted values:

```{r}
#| echo: false
#| out.width: 60%
knitr::include_graphics("out/fig_fitted.png")
```

## Discussion

Fertility was positively correlated with agriculture.

---
title: "Swiss Fertility"
---

## Introduction

We examine the relationship between agriculture and fertility in nineteenth century Swizterland.

## Methods

We fit a robust linear model to provincial-level data, using methods "M" and "MM".

## Results

Here are the raw data and the fitted values:

```{r}
#| echo: false
#| out.width: 60%
knitr::include_graphics("out/fig_fitted.png")
```

## Discussion

Fertility was positively correlated with agriculture.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cmd_assign.R
\name{cmd_assign}
\alias{cmd_assign}
\alias{cmd_assign_quiet}
\title{Assign Values Passed at the Command Line or Interactively}
\usage{
cmd_assign(...)

cmd_assign_quiet(...)
}
\arguments{
\item{...}{Name-value pairs.}
}
\value{
\code{cmd_assign()} is called
for its side effect, which is to create objects
in the global environment. However, \code{cmd_assign()}
also invisibly returns a named list of objects.
}
\description{
Assign values to names in the working environment.
The values are typically supplied through the command line,
but can be supplied interactively.

Specifying the inputs and outputs of scripts through the
command line can contribute to safter, more modular
workflows.

\code{cmd_assign_quiet()} is identical to \code{cmd_assign()},
but does not print progress messages to the console.
}
\section{Types of session}{
\code{cmd_assign()} behaves differently depending
on how it whether it is called
\enumerate{
\item interactively, or
\item inside an R script that is run from the command line.
}

For instance, if the code

\code{cmd_assign(use_log = TRUE)}

is run interactively, it creates an object
called \code{use_log} with value \code{TRUE}.

But if the same code is run inside a
script via the command

\verb{Rscript tidy_data.R --use_log=FALSE}

it creates an object called \code{use_log}
with value \code{FALSE}.

\code{cmd_assign()} is typically called interactively
when a workflow is being developed,
and through the command line when the
workflow has matured.
}

\section{Matching names and values}{
When used in a script called from the
command line, \code{cmd_assign()}
first matches named command line arguments,
and then matches unnamed command line arguments,
in the order in which they are supplied.

If, for instance, the script \code{person.R} contains
the lines

\if{html}{\out{<div class="sourceCode">}}\preformatted{cmd_assign(.data = "raw_data.csv",
           max_age = 85,
           .out = "person.rds")
}\if{html}{\out{</div>}}

and if \code{person.R} is run from the command line using

\if{html}{\out{<div class="sourceCode">}}\preformatted{Rscript person.R raw_data.csv person.rds --max_age=100
}\if{html}{\out{</div>}}

then \code{cmd_assign()} first matches named
command line argument \code{--max_age=100} to \verb{cmd_assign() argument }max_age\verb{, and then matches unnamed command line arguments }raw_data.csv\code{and}person.rds\code{to}cmd_assign()\code{arugments}.data\code{and}.out`.
}

\section{Coercing values passed at the command line}{
Values passed at the command line start out as
text strings. \code{cmd_assign()} coerces these text strings
to have the same class as the corresponding values
in the call to \code{cmd_assign()}. For instance,
if a script called \code{fit.R} contains
the lines

\if{html}{\out{<div class="sourceCode">}}\preformatted{cmd_assign(.data = "cleaned.rds",
           impute = TRUE,
           date = as.Date("2026-01-01"),
           .out = "fit.rds")
}\if{html}{\out{</div>}}

and if \code{fitted.R} is run from the command line using

\if{html}{\out{<div class="sourceCode">}}\preformatted{Rscript fitted.R cleaned.rds fit.rds --impute=TRUE --date=2025-01-01
}\if{html}{\out{</div>}}

then \code{cmd_assign()} will create
\itemize{
\item a character vector called \code{.data} with value "cleaned.rds",
\item a logical vector called \code{impute} with value \code{TRUE},
\item a date vector called \code{date} with value \code{"2025-01-01"}, and
\item a character vector called \code{.out} with value `"fit.rds".
}
}

\examples{
if (interactive()) {
  cmd_assign(.data = "mydata.csv",
             n_iter = 2000,
             .out = "results.rds")
}
}
\references{
\itemize{
\item \href{https://swcarpentry.github.io/r-novice-inflammation/05-cmdline.html}{Command-Line Programs}
Introduction to Rscript
}
}
\seealso{
\itemize{
\item \code{\link[=extract_shell]{extract_shell()}} Turn a \code{cmd_assign()} call into a shell command
\item \code{\link[=extract_make]{extract_make()}} Turn a \code{cmd_assign()} call into a Makefile rule
\item \code{\link[=shell_script]{shell_script()}} Create a shell script
\item \code{\link[=makefile]{makefile()}} Create a Makefile
\item \code{\link[=use_renv]{use_renv()}} Activate a renv project before loading packages
\item \href{https://bayesiandemography.github.io/command/articles/quickstart.html}{Quick Start}
How to use \code{cmd_assign()}
\item \href{https://bayesiandemography.github.io/command/articles/workflow.html}{Modular Workflows for Data Analysis}
Safe, flexible data analysis workflows.
\item \href{https://bayesiandemography.github.io/command/articles/a5_renv.html}{Using command with renv}
Running pipeline scripts with renv
\item Base R function \code{\link[=commandArgs]{commandArgs()}} uses a more general,
lower-level approach to processing command line arguments.
(\code{commandArgs()} is called internally by \code{cmd_assign()}.)
\item \href{https://CRAN.R-project.org/package=littler}{littler} Alternative to Rscript
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/shell_script.R
\name{shell_script}
\alias{shell_script}
\title{Create a Shell Script}
\usage{
shell_script(
  path_files,
  dir_shell = NULL,
  name_shell = "workflow.sh",
  overwrite = FALSE,
  quiet = FALSE
)
}
\arguments{
\item{path_files}{A path from \code{dir_shell} to a
directory with R scripts containing
calls to \code{\link[=cmd_assign]{cmd_assign()}}.}

\item{dir_shell}{The directory where
\code{shell_script()} will create the shell script.
If no value is supplied, then \code{shell_script()}
creates the shell script in the current working directory.}

\item{name_shell}{The name of the shell script.
The default is \code{"workflow.sh"}.}

\item{overwrite}{Whether to overwrite
an existing shell script. Default is \code{FALSE}.}

\item{quiet}{Whether to suppress
progress messages. Default is \code{FALSE}.}
}
\value{
\code{shell_script()} is called for its
side effect, which is to create a
file. However, \code{shell_script()} also
returns a string with the contents of the
shell script.
}
\description{
Create a shell script for a data analysis workflow
consisting of commands
extracted from existing R files.
}
\details{
To create a shell script in the \code{files}
directory, set \code{files} to \code{"."}.

To obtain the contents of the shell script
without creating a file on disk,
creating the file on disk, set
\code{name_shell} to \code{NULL}.

Supplying a value for \code{files} is
compulsory for \code{shell_script()},
but optional for \code{\link[=makefile]{makefile()}}.
The output from \code{shell_script()}
is generated entirely from \code{files}
while the output from \code{\link[=makefile]{makefile()}}
also includes some general-purpose Makefile
commands.
}
\examples{
library(withr)

with_tempdir({

  ## create 'src'  directory
  dir.create("src")

  ## put R scripts containing calls to
  ## 'cmd_assign' in the 'src' directory
  writeLines(c("cmd_assign(x = 1, .out = 'out/results.rds')",
               "results <- x + 1",
               "saveRDS(results, file = .out)"),
             con = "src/results.R")
  writeLines(c("cmd_assign(x = 1, .out = 'out/more_results.rds')",
               "more_results <- x + 2",
               "saveRDS(more_results, file = .out)"),
             con = "src/more_results.R")

  ## call 'shell_script()'
  shell_script(path_files = "src",
               dir_shell = ".")

  ## shell script has been created
  list.files()

  ## print contents of shell script
  cat(readLines("workflow.sh"), sep = "\n")

})
}
\references{
\itemize{
\item Episodes 1--3 of \href{https://swcarpentry.github.io/shell-novice/index.html}{The Unix Shell}
Introduction to the command line
\item \href{https://swcarpentry.github.io/r-novice-inflammation/05-cmdline.html}{Command-Line Programs}
Introduction to Rscript
}
}
\seealso{
\itemize{
\item \href{https://bayesiandemography.github.io/command/articles/a2_shell_script.html}{Creating a Shell Script} More on \code{shell_script()}
\item \code{\link[=extract_shell]{extract_shell()}} Turn a \code{\link[=cmd_assign]{cmd_assign()}} call into a shell command
\item \code{\link[=makefile]{makefile()}} Makefile equivalent of \code{shell_script()}
\item \code{\link[=cmd_assign]{cmd_assign()}} Process command line arguments
\item \href{https://bayesiandemography.github.io/command/articles/workflow.html}{Modular Workflows for Data Analysis}
Safe, flexible data analysis workflows
\item \href{https://CRAN.R-project.org/package=littler}{littler} Alternative to Rscript
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/use_renv.R
\name{use_renv}
\alias{use_renv}
\title{Activate an renv Project for the Current Session}
\usage{
use_renv(project = NULL, quiet = TRUE)
}
\arguments{
\item{project}{Optional path to a project root. If \code{NULL}
(the default), search upward from the script's directory
when known, otherwise from \code{getwd()}. The script directory
is taken from \code{Rscript}'s \verb{--file=} argument when present,
or from source references under littler.}

\item{quiet}{If \code{TRUE} (the default), suppress messages.}
}
\value{
The project root path (invisibly) if renv was activated
or was already active; otherwise \code{NULL}.
}
\description{
Make sure \code{renv} is activated, even if a script is run from
Rscript or littler.
}
\details{
Package \href{https://rstudio.github.io/renv/}{renv}
makes workflows reproducible by locking down the versions of
R packages. Normal \code{renv} mechanisms can fail, however,
if a script is run from Rscript or littler.
Adding

\if{html}{\out{<div class="sourceCode">}}\preformatted{command::use_renv()
}\if{html}{\out{</div>}}

to the top of R scripts fixes the problem.

For more details, see the article
\href{https://bayesiandemography.github.io/command/articles/a5_renv.html}{Using command with renv}.
}
\examples{
command::use_renv() ## if renv not used here, no effect

## see article for full example
}
\seealso{
\itemize{
\item \code{\link[=cmd_assign]{cmd_assign()}} Process command line arguments
\item \href{https://bayesiandemography.github.io/command/articles/a5_renv.html}{Using command with renv}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/extract_make.R
\name{extract_make}
\alias{extract_make}
\title{Turn a 'cmd_assign' Call Into a Makefile Rule}
\usage{
extract_make(path_file, dir_make = NULL)
}
\arguments{
\item{path_file}{A path from
\code{dir_make} to the R scripe containing
the call to \code{\link[=cmd_assign]{cmd_assign()}}.}

\item{dir_make}{The directory that contains
the Makefile. The default is
the current working directory.}
}
\value{
\code{extract_make()} is typically called
for its side effect, which is to print a
Makefile rule. However, \code{extract_make()}
invisibly returns a text string with the rule.
}
\description{
Extract a call to \code{\link[=cmd_assign]{cmd_assign()}} from an
R script, and turn it into a Makefile rule.
}
\section{The components of a Makefile rule}{
A Makefile rule produced by \code{extract_make()}
normally looks something like this:

\if{html}{\out{<div class="sourceCode">}}\preformatted{out/model.rds: src/model.R \\
  data/cleaned.rds
       Rscript $^ $@ --use_log=TRUE
}\if{html}{\out{</div>}}

In this rule
\itemize{
\item \code{out/model.rds} is the "target", i.e. the file that the rule creates;
\item \code{src/model.R} and \code{data/timeseries.rds} are "prerequisites",
i.e. files that are used to create the target;
\item \verb{\\} is a "line continuation character";
\item \verb{        } at the start of the third line is a tab,
telling \code{make} that the recipe for creating the target from
the starts here;
\item \code{Rscript} is a call to \code{\link[utils:Rscript]{utils::Rscript()}};
\item \verb{$^} is an \href{https://www.gnu.org/software/make/manual/make.html#Automatic-Variables}{automatic variable}
meaning "all the prerequisites"
and \verb{$@} is an automatic variable meaning "the target",
so that \verb{Rscript $^ $@} expands to
\verb{Rscript src/model.R data/cleaned.rds out/model.rds}; and
\item \code{--use_log=TRUE} is a named argument that
Rscript passes to \code{src/model.R}
}
}

\section{Using \code{extract_make()} to build a data analysis workflow}{
\itemize{
\item Step 1. Write the R file that carries out
the step in analysis (eg tidying data, fitting
a model, making a graph.) This file
will contain a call to \code{\link[=cmd_assign]{cmd_assign()}},
and  will appear in the first line of the
Makefile rule. When writing and testing the file,
use \code{\link[=cmd_assign]{cmd_assign()}} interactively.
\item Step 2. Once the R file is working correctly,
call \code{extract_make()}, and add the rule
to your Makefile.
}

When using \code{extract_make()}, it is a good idea to
set the current working directory to the project
directory (something that will happen automatically
if you are using RStudio projects.)
}

\section{Location of the Makefile}{
The Makefile normally sets at the top of
the project, so that the
project folder looks something like this:

\if{html}{\out{<div class="sourceCode">}}\preformatted{Makefile
- data/
- src/
- out/
report.qmd
}\if{html}{\out{</div>}}
}

\section{Identifying file arguments}{
To construct the Makefile rule, \code{extract_make()} needs to
be able to pick out arguments that refer to
file names. To do so, it uses the following heuristic:
\itemize{
\item if the call includes arguments whose names start with
a dot, then these arguments are assumed to
refer to file names;
\item otherwise, find arguments whose values
actually are file names
(as determined by \code{\link[=file.exists]{file.exists()}}), or that look
like they could be.
}
}

\examples{
library(withr)
with_tempdir({

  ## create 'src'  directory
  dir.create("src")

  ## put an R script containing a call to
  ## 'cmd_assign' in the 'src' directory
  writeLines(c("cmd_assign(x = 1, .out = 'out/results.rds')",
               "results <- x + 1",
               "saveRDS(results, file = .out)"),
             con = "src/results.R")

  ## call 'extract_make()'
  extract_make(path_file = "src/results.R",
               dir_make = ".")

})
}
\references{
\itemize{
\item \href{https://jeroenjanssens.com/dsatcl/chapter-6-project-management-with-make}{Project Management with Make}
Makefiles in data analysis workflows
\item \href{https://www.gnu.org/software/make/manual/make.html#SEC_Contents}{GNU make}
Definitive guide
\item \href{https://swcarpentry.github.io/r-novice-inflammation/05-cmdline.html}{Command-Line Programs}
Introduction to Rscript
}
}
\seealso{
\itemize{
\item \code{\link[=extract_shell]{extract_shell()}} Shell script equivalent of \code{extract_make()}
\item \code{\link[=makefile]{makefile()}} Create a Makefile
from calls to \code{\link[=cmd_assign]{cmd_assign()}}
\item \code{\link[=cmd_assign]{cmd_assign()}} Process command line arguments
\item \href{https://bayesiandemography.github.io/command/articles/quickstart.html}{Quick Start}
How to use \code{cmd_assign()}
\item \href{https://bayesiandemography.github.io/command/articles/workflow.html}{Modular Workflows for Data Analysis}
Safe, flexible data analysis workflows
\item \href{https://CRAN.R-project.org/package=littler}{littler} Alternative to Rscript
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/command-package.R
\docType{package}
\name{command-package}
\alias{command-package}
\alias{command}
\title{command: Process command line arguments}
\description{
Process command line arguments, allowing scripts to
behave like functions, with well-defined inputs and outputs.
Helps make data analysis workflows more modular,
and therefore more transparent, flexible, and reliable.
}
\details{
\itemize{
\item \code{\link[=cmd_assign]{cmd_assign()}} Process command line arguments
\item \code{\link[=use_renv]{use_renv()}} Activate a renv project before loading packages
\item \code{\link[=extract_shell]{extract_shell()}} Turn a \code{cmd_assign()} call into a shell command
\item \code{\link[=extract_make]{extract_make()}} Turn a \code{cmd_assign()} call into a Makefile rule
\item \code{\link[=shell_script]{shell_script()}} Create a shell script
\item \code{\link[=makefile]{makefile()}} Create a Makefile
\item \href{https://bayesiandemography.github.io/command/articles/quickstart.html}{Quick Start}
How to use \code{cmd_assign()}
\item \href{https://bayesiandemography.github.io/command/articles/workflow.html}{Modular Workflows for Data Analysis}
Safe, flexible data analysis workflows
\item \href{https://bayesiandemography.github.io/command/articles/a5_renv.html}{Using command with renv}
Running pipeline scripts with renv
}
}
\seealso{
Useful links:
\itemize{
  \item \url{https://bayesiandemography.github.io/command/}
  \item \url{https://github.com/bayesiandemography/command}
  \item Report bugs at \url{https://github.com/bayesiandemography/command/issues}
}

}
\author{
\strong{Maintainer}: John Bryant \email{john@bayesiandemography.com}

Authors:
\itemize{
  \item John Bryant \email{john@bayesiandemography.com}
}

Other contributors:
\itemize{
  \item Bayesian Demography Limited [copyright holder]
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/extract_shell.R
\name{extract_shell}
\alias{extract_shell}
\title{Turn a 'cmd_assign' Call Into a Shell Command}
\usage{
extract_shell(path_file, dir_shell = NULL)
}
\arguments{
\item{path_file}{Path to the R script containing
the call to \code{\link[=cmd_assign]{cmd_assign()}}. The path
starts at \code{dir_shell}.}

\item{dir_shell}{The directory that contains
the shell script. The default is
the current working directory.}
}
\value{
\code{extract_shell()} is typically called
for its side effect, which is to print a
shell command. However, \code{extract_shell()}
invisibly returns a text string with the command.
}
\description{
Extract a call to \code{\link[=cmd_assign]{cmd_assign()}} from an
R script, and turn it into a shell command.
}
\section{The components of a shell command}{
The shell command produced by \code{extract_shell()}
normally looks something like this:

\if{html}{\out{<div class="sourceCode">}}\preformatted{Rscript src/model.R \\
  data/cleaned.rds \\
  out/model.rds \\
  --use_log=TRUE
}\if{html}{\out{</div>}}

In this command
\itemize{
\item \code{Rscript} is a call to \code{\link[utils:Rscript]{utils::Rscript()}};
\item \verb{\\} is a "line continuation character";
\item \code{data/cleaned.rds} and \code{out/model.rds} are unnamed
arguments that Rscript passes to \code{src/model.R}; and
\item \code{--use_log=TRUE} is a named argument that
Rscript passes to \code{src/model.R}
}
}

\section{Using \code{extract_shell()} to build a data analysis workflow}{
\itemize{
\item Step 1. Write an R script that carries out
a step in analysis (eg tidying data, fitting
a model, making a graph.) This script
will contain a call to \code{\link[=cmd_assign]{cmd_assign()}},
and  will be the first argument passed to
Rscript in the shell command.
When writing and testing the script,
use \code{\link[=cmd_assign]{cmd_assign()}} interactively.
\item Step 2. Once the R script is working correctly,
call \code{extract_shell()}, and add the command
to your shell script.
}
}

\section{Location of the shell script}{
The shell script normally sits at the
top level of the project, so that the
project folder looks something like this:

\if{html}{\out{<div class="sourceCode">}}\preformatted{workflow.sh
- data/
- src/
- out/
report.qmd
}\if{html}{\out{</div>}}
}

\section{Identifying file arguments}{
To construct the rule, \code{extract_shell()} needs to
be able to identify arguments that refer to a
file name. To do so, it uses the following heuristic:
\itemize{
\item if the call includes arguments whose names start with
a dot, then these arguments are assumed to
refer to file names;
\item otherwise, find arguments whose values
actually are file names
(as determined by \code{\link[=file.exists]{file.exists()}}) or that look
like they could be.
}
}

\examples{
library(withr)

with_tempdir({

  ## create 'src' directory
  dir.create("src")

  ## add an R script containing a call to 'cmd_assign'
  writeLines(c("cmd_assign(x = 1, .out = 'out/results.rds')",
               "results <- x + 1",
               "saveRDS(results, file = .out)"),
             con = "src/results.R")

  ## call 'extract_shell()'
  extract_shell(path_file = "src/results.R",
                dir_shell = ".")

})
}
\references{
\itemize{
\item Episodes 1--3 of \href{https://swcarpentry.github.io/shell-novice/index.html}{The Unix Shell}
Introduction to the command line
\item \href{https://swcarpentry.github.io/r-novice-inflammation/05-cmdline.html}{Command-Line Programs}
Introduction to Rscript
\item \href{https://CRAN.R-project.org/package=littler}{littler} Alternative to Rscript
}
}
\seealso{
\itemize{
\item \code{\link[=extract_make]{extract_make()}} Makefile equivalent of \code{extract_shell()}
\item \code{\link[=shell_script]{shell_script()}} Create a shell script
from calls to \code{\link[=cmd_assign]{cmd_assign()}}
\item \code{\link[=cmd_assign]{cmd_assign()}} Process command line arguments
\item \href{https://bayesiandemography.github.io/command/articles/quickstart.html}{Quick Start}
How to use \code{cmd_assign()}
\item \href{https://bayesiandemography.github.io/command/articles/workflow.html}{Modular Workflows for Data Analysis}
Safe, flexible data analysis workflows
}
}
